package oldApps;

import java.applet.Applet;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Label;
import java.awt.LayoutManager;
import java.awt.Scrollbar;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import javax.swing.BoxLayout;

public class CollisionFramed extends Applet implements ComponentListener {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	CollisionFrame ogf;
	boolean started = false;
    void destroyFrame() {
    	if (ogf != null) { ogf.dispose(); }
    	ogf = null;
    	repaint();
    }
    public void init() { addComponentListener(this); }
    void showFrame() {
		if (ogf == null) {
		    started = true;
		    ogf = new CollisionFrame(this);
		    ogf.init();
		    repaint();
		}
    }
    public void paint(Graphics g) {
		String s = "Applet is open in a separate window.";
		if (!started) { s = "Applet is starting."; }
		else if (ogf == null) { s = "Applet is finished."; }
		else { ogf.triggerShow(); }
		g.drawString(s, 10, 30);
    }
    public void componentHidden(ComponentEvent e){}
    public void componentMoved(ComponentEvent e){}
    public void componentShown(ComponentEvent e) { showFrame(); }
    public void componentResized(ComponentEvent e) {}
    public void destroy() {
		if (ogf != null) { ogf.dispose(); }
		ogf = null;
		repaint();
    }
}

class CollisionCanvas extends Canvas {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	CollisionFrame pg;
    CollisionCanvas(CollisionFrame p) { pg = p; }
    public Dimension getPreferredSize() { return new Dimension(300,400); }
    public void update(Graphics g) { pg.updateCollision(g); }
    public void paint(Graphics g) { pg.updateCollision(g); }
}

class CollisionLayout implements LayoutManager {
	public CollisionLayout() {}
	public void addLayoutComponent(String name, Component c) {}
	public void removeLayoutComponent(Component c) {}
	public Dimension preferredLayoutSize(Container target) { return new Dimension(500, 500); }
	public Dimension minimumLayoutSize(Container target) {	return new Dimension(100,100);	}
	@SuppressWarnings("deprecation")
	public void layoutContainer(Container target) {
		Insets insets = target.insets();
		int targetw = target.size().width - insets.left - insets.right;
		int cw = targetw* 8/10;
		int targeth = target.size().height - (insets.top+insets.bottom);
		target.getComponent(0).move(insets.left, insets.top);
		target.getComponent(0).resize(cw, targeth);
		int barwidth = targetw - cw;
		cw += insets.left;
		int i;
		int h = insets.top;
		for (i = 1; i < target.getComponentCount(); i++) {
		    Component m = target.getComponent(i);
		    if (m.isVisible()) {
			Dimension d = m.getPreferredSize();
			if (m instanceof Scrollbar)
			    d.width = barwidth;
			if (m instanceof Choice && d.width > barwidth)
			    d.width = barwidth;
			if (m instanceof Label) {
			    h += d.height/5;
			    d.width = barwidth;
			}
			m.move(cw, h);
			m.resize(d.width, d.height);
			h += d.height;
		    }
		}
	}
}




class CollisionFrame extends Frame implements ComponentListener, ActionListener, AdjustmentListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Dimension winSize;
//	Thread engine = null;
	CollisionCanvas cv;
	CollisionFramed applet;
	boolean shown = false;
	private double mass1, mass2, veloc1, veloc2, time, time2, collision, vfa, vfb,vfat,vfbt;
	private boolean running, collide;
	Scrollbar m1Bar;
	Scrollbar m2Bar;
	Scrollbar v1Bar;
	Scrollbar v2Bar;	
	Scrollbar speedBar;
	Button resetButton;
	Button resetDataButton;
	Button runButton;
	Label m1Label;
	Label v1Label;
	Label m2Label;
	Label v2Label;	
	Label output_line1, output_line2, output_line3, output_line4, output_line5, output_line6, output_line7, output_line8;
	boolean useBufferedImage = false;
	
	
	
	

	
	
	CollisionFrame(CollisionFramed a) { super("Collision Applet v1.01"); applet = a; }
	public String getAppletInfo() { return "Collisions Applet";	}
    public void componentHidden(ComponentEvent e){}
    public void componentMoved(ComponentEvent e){}
    public void componentShown(ComponentEvent e) { cv.repaint(); }
    public void componentResized(ComponentEvent e) { handleResize(); cv.repaint(100); }
    @SuppressWarnings("deprecation")
	public void triggerShow() {
    	if (!shown)
    	    show();
    	shown = true;
    }
	@SuppressWarnings("deprecation")
	public void init() {
//		setupList = new Vector();
//		Setup s = new SingleSourceSetup();
//		while (s != null) {
//			setupList.addElement(s);
//			s = s.createNext();
//		}
//		String os = System.getProperty("os.name");
//		int res = 110;
		String jv = System.getProperty("java.class.version");
		double jvf = new Double(jv).doubleValue();
		if (jvf >= 48)
		useBufferedImage = true;
		
//		sources = new OscSource[20];
		setLayout(new CollisionLayout());
		cv = new CollisionCanvas(this);
		cv.addComponentListener(this);
		add(cv);
		
		cv.setBackground(Color.black);
		cv.setForeground(Color.lightGray);
		
		add(new Label("test"));

		mass1 = 1000;
		m1Label = new Label("Mass of Object 1: " + mass1, Label.CENTER);
		add(m1Label);
		add(m1Bar = new Scrollbar(Scrollbar.HORIZONTAL, ((Long) Math.round(mass1)).intValue(), 300, 500, 2300));
		m1Bar.addAdjustmentListener(this);
		mass1 = m1Bar.getValue();
		
		veloc1 = 10;
		v1Label = new Label("Velocity of Object 1: " + veloc1, Label.CENTER);
		add(v1Label);
		add(v1Bar = new Scrollbar(Scrollbar.HORIZONTAL, ((Long) Math.round(veloc1)).intValue(), 1, 0, 26));
		v1Bar.addAdjustmentListener(this);
		veloc1 = v1Bar.getValue();
		
		mass2 = 1000;
		m2Label = new Label("Mass of Object 2: " + mass2, Label.CENTER);
		add(m2Label);
		add(m2Bar = new Scrollbar(Scrollbar.HORIZONTAL, ((Long) Math.round(mass2)).intValue(), 300, 500, 2300));
		m2Bar.addAdjustmentListener(this);
		mass2 = m2Bar.getValue();
		
		veloc2 = 10;
		v2Label = new Label("Velocity of Object 2: " + veloc2, Label.CENTER);
		add(v2Label);
		add(v2Bar = new Scrollbar(Scrollbar.HORIZONTAL, ((Long) Math.round(veloc2)).intValue(), 1, 0, 26));
		v2Bar.addAdjustmentListener(this);		
		veloc2 = v2Bar.getValue();
		
//		add(new Label("Simulation Speed", Label.CENTER));
//		add(speedBar = new Scrollbar(Scrollbar.HORIZONTAL, 8, 1, 1, 100));
//		speedBar.addAdjustmentListener(this);		
		
		add(runButton = new Button("Run Collision"));
		runButton.addActionListener(this);
		add(resetButton = new Button("Reset Collision"));
		resetButton.addActionListener(this);
		add(resetDataButton = new Button("Reset Data"));
		resetDataButton.addActionListener(this);
		
		output_line1 = new Label("", Label.LEFT);
		add(output_line1);
		output_line2 = new Label("", Label.LEFT);
		add(output_line2);
		output_line3 = new Label("", Label.LEFT);
		add(output_line3);
		output_line4 = new Label("", Label.LEFT);
		add(output_line4);		
		output_line5 = new Label("", Label.LEFT);
		add(output_line5);
		output_line6 = new Label("", Label.LEFT);
		add(output_line6);
		output_line7 = new Label("", Label.LEFT);
		add(output_line7);
		output_line8 = new Label("", Label.LEFT);
		add(output_line8);		
		
		
		
		reinit();
		
		resize(800, 540);
		handleResize();
		Dimension x = getSize();
		Dimension screen = getToolkit().getScreenSize();
		setLocation((screen.width  - x.width)/2,
			    (screen.height - x.height)/2);
		show();
		
	}
    public void actionPerformed(ActionEvent e) {
		if (e.getSource() == runButton) {
	    	if (winSize == null || winSize.width == 0) {
	    	    handleResize();
	    	    return;
	        }
			int collision_interval = ((Long) Math.round(.5*winSize.width)).intValue();
			running = true;
			collision = ((collision_interval - (mass1/20)) / ((veloc1 + veloc2)));
			vfa = (((mass1 - mass2) / (mass1 + mass2)) * veloc1 + ((2 * mass2) / (mass1 + mass2)) * (-veloc2));
			vfb = -(((mass2 - mass1) / (mass1 + mass2)) * (-veloc2) + ((2 * mass1) / (mass1 + mass2)) * veloc1);
			long x=(long)(vfa*100);
			vfat=(double)x/100;
			long y=(long)(vfb*100);
			vfbt=(double)y/100;
		}
		if (e.getSource() == resetButton) {
			running = false;
			//restart = true;
			time = 0;
			time2=0;
			collide = false;
			output_line1.setText("");
			output_line2.setText("");
			output_line3.setText("");
			output_line4.setText("");
			output_line5.setText("");
			output_line6.setText("");
			output_line7.setText("");
			output_line8.setText("");	
		}
		if (e.getSource() == resetDataButton) {
			reset_defaults();
			running = false;
			//restart = true;
			time = 0;
			time2=0;
			collide = false;
			output_line1.setText("");
			output_line2.setText("");
			output_line3.setText("");
			output_line4.setText("");
			output_line5.setText("");
			output_line6.setText("");
			output_line7.setText("");
			output_line8.setText("");					
		}		
		cv.repaint();
	}
    void handleResize() {
        winSize = cv.getSize();
		if (winSize.width == 0)
		    return;
    }

    @SuppressWarnings("deprecation")
	public boolean handleEvent(Event ev) {
        if (ev.id == Event.WINDOW_DESTROY) {
            applet.destroyFrame();
            return true;
        }
        return super.handleEvent(ev);
    }

    void reinit() { reinit(true); }
        
    void reinit(boolean setup) {
//    	sourceCount = -1;
//    	System.out.print("reinit " + gridSizeX + " " + gridSizeY + "\n");
//    	gridSizeXY = gridSizeX*gridSizeY;
//    	gw = gridSizeY;
		time2=0;
		time = 0;
		collide = false;
    }
    
    void reset_defaults()
    {
    	
		mass1 = 1000;
		m1Bar.setValue(((Long) Math.round(mass1)).intValue());
	    m1Label.setText("Mass of Object 1: " + mass1);
		mass2 = 1000;
		m2Bar.setValue(((Long) Math.round(mass2)).intValue());
		m2Label.setText("Mass of Object 2: " + mass2);
		veloc1 = 10;
		v1Bar.setValue(((Long) Math.round(veloc1)).intValue());
		v1Label.setText("Velocity of Object 1: " + veloc1);
		veloc2 = 10;
		v2Bar.setValue(((Long) Math.round(veloc2)).intValue());
		v2Label.setText("Velocity of Object 2: " + veloc2);		
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
    	System.out.print(((Scrollbar) e.getSource()).getValue() + "\n");
    	if (e.getSource() == m1Bar) {
    	    mass1 = ((Scrollbar) e.getSource()).getValue();
    	    m1Label.setText("Mass of Object 1: " + mass1);
    	}
    	if (e.getSource() == m2Bar) {
    		mass2 = ((Scrollbar) e.getSource()).getValue();
    		m2Label.setText("Mass of Object 2: " + mass2);
    	}
    	if (e.getSource() == v1Bar) {
    		veloc1 = ((Scrollbar) e.getSource()).getValue();
    		v1Label.setText("Velocity of Object 1: " + veloc1);
    	}
    	if (e.getSource() == v2Bar) {
    		veloc2 = ((Scrollbar) e.getSource()).getValue();
    		v2Label.setText("Velocity of Object 2: " + veloc2);
    		
    	}
    	cv.repaint();
    }
  
    
    public void updateCollision(Graphics realg) {
    	if (winSize == null || winSize.width == 0) {
    	    handleResize();
    	    return;
        }
    	realg.setColor(Color.BLACK);
    	realg.fillRect(0, 0, winSize.width, winSize.height);
    	
    	realg.setColor(Color.WHITE);
    	//realg.drawString("Initial Velocity of Cart 1: "+veloc1, 20, 250);
    	//realg.drawString("Initial Velocity of Cart 2: "+(-veloc2), 20, 300);
    	int graph_zero = ((Long) Math.round(.8*winSize.height)).intValue();
    	double velocity_modifer = (.1*winSize.height)/25;
    	int collision_plane = ((Long) Math.round(.3*winSize.height)).intValue();
    	
    	realg.drawLine(20, graph_zero, ((Long) Math.round(.9*winSize.width)).intValue(), graph_zero);
    	realg.drawLine(20, ((Long) Math.round(.7*winSize.height)).intValue(), 20, ((Long) Math.round(.9*winSize.height)).intValue());
    	realg.drawString("V", 20, ((Long) Math.round(.68*winSize.height)).intValue());
    	int increment_size = ((Long) Math.round((.9*winSize.width)/21)).intValue();
		for (int a = 1; a < 21; a++)
		{
			realg.drawLine(20 + a * increment_size, ((Long) Math.round(.75*winSize.height)).intValue(), 20 + a * increment_size, ((Long) Math.round(.85*winSize.height)).intValue());}
		if (!collide&&running)
		{
			realg.setColor(Color.BLUE);
			realg.drawLine(20, (int)(graph_zero - (veloc1*velocity_modifer)), (int)(20 + time * 20), (int)(graph_zero - (veloc1*velocity_modifer)));
			realg.fillOval((int)(((Long) Math.round(.2*winSize.width)).intValue() + (time * veloc1)), (int)(collision_plane - (mass1/40)), (int)(mass1/20), (int)(mass1/20));
			realg.setColor(Color.RED);
			realg.drawLine(20, (int)(graph_zero + (veloc2*velocity_modifer)), (int)(20 + time * 20), (int)(graph_zero +(veloc2*velocity_modifer)));
			realg.fillOval((int)(((Long) Math.round(.7*winSize.width)).intValue() - (time * veloc2)), (int)(collision_plane - (mass2/40)), (int)(mass2/20), (int)(mass2/20));
			realg.drawString(""+(int) mass1, (int)(((Long) Math.round(.215*winSize.width)).intValue() + (time * veloc1)), (collision_plane));
			realg.setColor(Color.BLUE);
			realg.drawString(""+(int) mass2, (int)(((Long) Math.round(.715*winSize.width)).intValue()- (time * veloc2)),collision_plane);}
		if (collide == true && running == true)
		{
			realg.setColor(Color.BLUE);
			realg.drawLine((int)(20+time2*20), (int)(graph_zero-(veloc1*velocity_modifer)), (int) (20+time2*20), (int)(graph_zero - (vfa*velocity_modifer)));
			realg.drawLine(20,(int) (graph_zero-(veloc1*velocity_modifer)),(int)(20+time2*20),(int)(graph_zero-(veloc1*velocity_modifer)));
			realg.drawLine((int) (20+time2*20), (int)(graph_zero - (vfa*velocity_modifer)), (int)(20 + (time2 + time) * 20), (int)(graph_zero - (vfa*velocity_modifer)));
			realg.fillOval((int)((((Long) Math.round(.2*winSize.width)).intValue() + collision * veloc1) + (time * vfa)),(int)(collision_plane - (mass1/40)), (int)(mass1/20), (int)(mass1/20));
			realg.setColor(Color.RED);
			realg.drawLine((int)(20+time2*20), (int)(graph_zero+(veloc2*velocity_modifer)), (int) (20+time2*20), (int)(graph_zero + (vfb*velocity_modifer)));
			realg.drawLine(20,(int) (graph_zero+(veloc2*velocity_modifer)),(int)(20+time2*20),(int)(graph_zero+(veloc2*velocity_modifer)));
			realg.drawLine((int) (20+time2*20), (int)(graph_zero + (vfb*velocity_modifer)), (int)(20 + (time2 + time) * 20), (int)(graph_zero + (vfb*velocity_modifer)));
			realg.fillOval((int)((((Long) Math.round(.7*winSize.width)).intValue() - collision * veloc2) - (time * vfb)), (int)(collision_plane - (mass2/40)), (int)(mass2/20), (int)(mass2/20));
			realg.drawString(""+(int) mass1, (int)(((Long) Math.round(.215*winSize.width)).intValue() + (collision * veloc1) + (time * vfa)), (collision_plane));
			realg.setColor(Color.BLUE);
			realg.drawString(""+(int) mass2, (int)((((Long) Math.round(.715*winSize.width)).intValue()- collision * veloc2) - (time * vfb)),collision_plane);
			//realg.drawString("Final Velocity of Cart 1: "+vfat, 250, 250);
			//realg.drawString("Final Velocity of Cart 2: "+(-vfbt), 250, 300);
		}
		if (collide == true && running == false)
		{
			realg.setColor(Color.BLUE);
			realg.drawLine((int)(20+time2*20), (int)(graph_zero - (veloc1*velocity_modifer)), (int) (20+time2*20), (int)(graph_zero - (vfa*velocity_modifer)));
			realg.drawLine(20,(int) (graph_zero-(veloc1*velocity_modifer)),(int)(20+time2*20),(int)(graph_zero-(veloc1*velocity_modifer)));
			realg.drawLine((int) (20+time2*20), (int)(graph_zero - (vfa*velocity_modifer)), (int)(20 + (time2 + time) * 20), (int)(graph_zero - (vfa*velocity_modifer)));
			realg.setColor(Color.RED);
			realg.drawLine((int)(20+time2*20), (int)(graph_zero + (veloc2*velocity_modifer)), (int) (20+time2*20), (int)(graph_zero + (vfb*velocity_modifer)));
			realg.drawLine(20,(int) (graph_zero+(veloc2*velocity_modifer)),(int)(20+time2*20),(int)(graph_zero+(veloc2*velocity_modifer)));
			realg.drawLine((int) (20+time2*20), (int)(graph_zero + (vfb*velocity_modifer)), (int)(20 + (time2 + time) * 20), (int)(graph_zero + (vfb*velocity_modifer)));
			System.out.println(time);
			realg.setColor(Color.BLUE);
			realg.fillOval((int)((((Long) Math.round(.2*winSize.width)).intValue() + collision * veloc1) + (time * vfa)), (int)(collision_plane - (mass1/40)), (int)(mass1/20), (int)(mass1/20));
			realg.fillOval((int)((((Long) Math.round(.7*winSize.width)).intValue() - collision * veloc2) - (time * vfb)), (int)(collision_plane - (mass2/40)), (int)(mass2/20), (int)(mass2/20));
			//realg.drawString("Final Velocity of Cart 1: "+vfat, 250, 250);
			//realg.drawString("Final Velocity of Cart 2: "+(-vfbt), 250, 300);
			
			//Label output_line1, output_line2, output_line3, output_line4;
			output_line3.setText("Mass 1: " + mass1 );
			output_line4.setText("Mass 2: " + mass2 );
			output_line5.setText("V1(initial): " + veloc1  );
			output_line6.setText("V2(initial): " + -veloc2 );
			output_line7.setText("V1(final): " + vfat  );
			output_line8.setText("V2(final): " + -vfbt );
		}
		if(running == true)
		{running();}        	
    }    
    
	public void running()
	{
		time = time + .1;
		if (time >= collision && collide == false)
		{
			collide = true;
			time2 = time;
			time = 0;
		}
		if(collide==true&&(time - time2)>2){
			running=false;
		}
		try
		{
			Thread.sleep(30);
		}
		catch (Exception e)
		{
		}
		cv.repaint();
	}
    
        
}
