package phyApps.common;

import java.awt.Button;
import java.awt.Component;
import java.awt.Label;
import java.awt.Scrollbar;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentListener;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

@SuppressWarnings("serial")
public class InputRow extends InputArea implements Iterable<Component>, ActionListener {

	private List<Component> components;
	private ActionListener listener;
	
	public InputRow() {
		components = new LinkedList<Component>();
	}
	
	public void add(Button button, String command, ActionListener listener) {
		this.listener = listener;
		button.setActionCommand(command);
		button.addActionListener(this);
		components.add(button);
	}

	public void add(Scrollbar scrollbar) {
		components.add(scrollbar);
	}

	public void add(TextField field) {
		components.add(field);
	}

	public void add(Label label) {
		components.add(label);
	}
	
	public Iterator<Component> iterator() {
		return components.iterator();
	}
	
	public Collection<Component> getRowComponents() {
		return components;
	}
	
	public void add(TextField field, String name) {
		throw new UnsupportedOperationException();
	}

	public void add(Scrollbar scrollbar, AdjustmentListener listener) {
		throw new UnsupportedOperationException();
	}

	public void add(Scrollbar scrollbar, AdjustmentListener listener, String name) {
		throw new UnsupportedOperationException();
	}

	public void add(Label label, String name) {
		throw new UnsupportedOperationException();
	}

	public void actionPerformed(ActionEvent event) {
		event.setSource(this);
		listener.actionPerformed(event);
	}
}
