package phyApps.common.graph;

abstract public class LocationPlot extends Plot {

	protected Point location;
	
	public LocationPlot(Graph graph, Point point) {
		super(graph);
		location = point;
	}
	
	// for the user:
	
	public void move(Point newLocation) {
		location = newLocation;
	}
	
	public Point getLocation() {
		return location;
	}
	
	public void clear() {
		move(null);
	}
	
	// for graph:
	
	public boolean isEmpty() {
		return location == null;
	}
	
	public Region determineRegion() {
		return new Region(location.getX(), location.getY(), location.getX(), location.getY());
	}

}
