package phyApps.common.graph;

public class Point {
	
	private double x;
	private double y;
	
	/**
	 * Make a new point. x and y are abstract coordinates.
	 */
	public Point(double x, double y) {
		this.x = x;
		this.y = y;
	}
	
	public Point(Point other) {
		this.x = other.x;
		this.y = other.y;
	}
	
	@Override
	public String toString() {
		return "(" + Double.toString(x) + ", " + Double.toString(y) + ")";
	}
	
	public double getX() {
		return x;
	}
	
	public double getY() {
		return y;
	}
	
	public static Point sum(Point A, Point B) {
		return new Point(A.x + B.x, A.y + B.y);
	}
	
	public static Point multiply(double scalar, Point P) {
		return new Point(P.x * scalar, P.y * scalar);
	}
	
	public static Point polarToCartesian(double magnitude, double angle) {
		return new Point(magnitude * Math.cos(angle), magnitude * Math.sin(angle));
	}
}
