package phyApps.common.graph;

import java.awt.Color;
import java.awt.Graphics;

/*
 * A plot of a single point.
 */
public class PointPlot extends LocationPlot {

	private Color color;
	public int RADIUS = 3;
	
	// for the user:
	
	public PointPlot(Graph graph, Color color) {
		this(graph, null, color);
	}
	
	public PointPlot(Graph graph, Point point, Color color) {
		super(graph, point);
		this.color = color;
	}
	
	public PointPlot(Graph graph, Color color, Region region) {
		this(graph, null, color, region);
	}
	
	public PointPlot(Graph graph, Point point, Color color, Region region) {
		this(graph, point, color);
		setRegion(region);
	}
	
	public void clear() {
		move(null);
	}
	
	/**
	 *  Set the radius in pixels.
	 */
	public void setRadius(int radius) {
		RADIUS = radius;
	}
	
	/**
	 * Set the radius using a point in abstract coordinates.
	 * The radius will be chosen so that the point is on the perimeter of the circle.
	 */
	public void setPerimeter(Point pointOnPerim) {
		RADIUS = graph.getCoordinateSpace().screenDistance(location, pointOnPerim);
	}
	
	// for graph:
	
	public void draw(Graphics g) {
		graph.drawPoint(g, location, color, RADIUS);
	}
}
