package phyApps.common.graph;

import java.awt.Dimension;

public class Region {
	
	public double left;
	public double right;
	public double bottom;
	public double top;
	
	public Region(Region other) {
		this.left = other.left;
		this.right = other.right;
		this.bottom = other.bottom;
		this.top = other.top;
	}
	
	public Region(double left, double bottom, double right, double top) {
		this.left = Math.min(left, right);
		this.right = Math.max(left, right);
		this.bottom = Math.min(bottom, top);
		this.top = Math.max(bottom, top);
	}
	
	public Region(Dimension size) {
		this.left = 0;
		this.top = 0;
		this.top = size.getWidth();
		this.bottom = size.getHeight();
	}

	/**
	 * Combine two regions to form a larger one that encompasses both.
	 */
	public static Region combine(Region reg1, Region reg2) {
		if (reg1 == null)
			return new Region(reg2);
		if (reg2 == null)
			return new Region(reg1);
		return new Region(Math.min(reg1.left, reg2.left), Math.min(reg1.bottom, reg2.bottom),
				Math.max(reg1.right, reg2.right), Math.max(reg1.top, reg2.top));
	}
}
