package phyApps.common.graph;

import java.awt.Color;
import java.awt.Graphics;

public class TargetPlot extends LocationPlot {

	private double radius;
	private Color foreground;
	private Color background;
	
	public TargetPlot(Graph graph, double radius, Color foreground, Color background) {
		super(graph, null);
		this.radius = radius;
		this.foreground = foreground;
		this.background = background;
	}

	public void draw(Graphics g) {
		// r is the radius in pixels.
		int r = graph.getCoordinateSpace().screenDistance(new Point(0, 0), new Point(0, radius));
		graph.drawPoint(g, location, foreground, r);
		graph.drawPoint(g, location, background, 3*r/4);
		graph.drawPoint(g, location, foreground, r/2);
		graph.drawPoint(g, location, background, r/4);
	}
}
