

package WebBuilder;


import java.io.*;
import java.util.zip.*;
import java.awt.Button;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.LayoutManager;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;

import WebBuilder.PageDialog;

/* PopupMenuDemo.java requires images/middle.gif. */

/*
 * Like MenuDemo, but with popup menus added.
 */
public class Interface implements ActionListener, ItemListener {
	static JFrame frame;
    JTextArea output;
	Button b, mod_header, mod_footer, mod_home, mod_menu;
	Button mod_page, mod_course, mod_document, other;
	Button add_page, add_course, add_document;
	JList scrlist_header;
	
    JScrollPane scrollPane;
    
    String newline = "\n";
    
    String Webpage_name= null;
    WebpageDB db = null;
    
    public JMenuBar createMenuBar() {
        JMenuBar menuBar;
        JMenu menu, submenu;
        JMenuItem menuItem;


        //Create the menu bar.
        menuBar = new JMenuBar();

        //Build the first menu.
        menu = new JMenu("Main");
        menu.setMnemonic(KeyEvent.VK_A);
        menu.getAccessibleContext().setAccessibleDescription(
                "Contains the main options for using the program");
        menuBar.add(menu);

        //a group of JMenuItems
        menuItem = new JMenuItem("New Webpage");
        //menuItem.setMnemonic(KeyEvent.VK_T); //used constructor instead
        //menuItem.setAccelerator(KeyStroke.getKeyStroke( KeyEvent.VK_1, ActionEvent.ALT_MASK));
        menuItem.getAccessibleContext().setAccessibleDescription(
                "Creates a new database to build a website");
        menuItem.addActionListener(this);
        menu.add(menuItem);

        //ImageIcon icon = createImageIcon("middle.gif");
        menuItem = new JMenuItem("Load Webpage");
//        menuItem.setMnemonic(KeyEvent.VK_B);
        menuItem.addActionListener(this);
        menu.add(menuItem);

        return menuBar;
    }

    public Container createContentPane() {
        JPanel LeftPane = new JPanel();
        
        JPanel controlPanel = new JPanel(new GridLayout(1,1));
        
        LeftPane.setOpaque(true);
        
        Label welcomelabel1;
        Label welcomelabel2;
        Label welcomelabel3;

//        mod_header = new Button("~");
//        mod_header.setSize(20, 20);
//        mod_header.addActionListener(new ButtonPress(2));
//        LeftPane.add(mod_header);
        
        welcomelabel1 = new Label("Welcome to the Webpage Builder. Use the dropdown menu to continue.");
        LeftPane.add(welcomelabel1);
//        welcomelabel2 = new Label(" ");
//        LeftPane.add(welcomelabel2);
//        welcomelabel3 = new Label("access databases is via the drop down menu");
//        LeftPane.add(welcomelabel3);
        
        //Create a scrolled text area.
        output = new JTextArea(5,40);
        output.setEditable(false);
        scrollPane = new JScrollPane(output);

        //Add the text area to the content pane.
        LeftPane.add(scrollPane);

		controlPanel.add(LeftPane);
//		controlPanel.add(RightPane);
		
        return controlPanel;
    }

     
    

    public void actionPerformed(ActionEvent e) {
        JMenuItem source = (JMenuItem)(e.getSource());
        String s = source.getText();
        output.append(s + newline);
        output.setCaretPosition(output.getDocument().getLength());
        
        
        if (source.getText()=="New Webpage") {

			 JTextField db_name_field = new JTextField();
			 final Frame f = new Frame();
			 //f.setSize(300, 300);
			 f.setVisible (false);
		
		      final JDialog jd = new JDialog (f, "New Database", true);
		      jd.setSize(300, 100);
		      jd.setLayout (new GridLayout (0, 1));
		      JLabel jl = new JLabel ("New database name"); 
		      jd.add (jl);
		      db_name_field.setBackground (Color.lightGray);
		      
		      db_name_field.addActionListener (new ActionListener() {
		          public void actionPerformed (ActionEvent e) {
		              jd.dispose();
		              f.dispose();
		            }
		          });

		      
		      jd.add (db_name_field);
		      JButton jb = new JButton ("OK");
		      jd.add (jb);
		      jb.addActionListener (new ActionListener() {
		          public void actionPerformed (ActionEvent e) {
		              jd.dispose();
		              f.dispose();
		            }
		          });
		      jd.pack();
		      jd.setVisible(true);
		      
		    if (db_name_field.getText().equals("")) {
		    	return;
		    	
		    }
        	String db_name = db_name_field.getText();
        	
        	Webpage_name = db_name;
        	
	        //check for the presence of this db already. if it already exists fail
	        File fF = new File(db_name + "/" + db_name + ".properties");
	        if (fF.exists()) {
	        	System.out.println("database already exists");
	        } else {
		        try {
		            db = new WebpageDB(db_name);
		            db.initialize();
		        } catch (Exception ex1) {
		            ex1.printStackTrace();    // could not start db
		        }
		        testdesignframe testframe = new testdesignframe(db);
		        testframe.show();
		        
	        }
        }
        if (source.getText()=="Load Webpage") {
        	
    	
            final JFileChooser fc = new JFileChooser();
            fc.setCurrentDirectory(new File("./"));
            
            fc.showOpenDialog(frame);

            // Get the selected file
            File selFile = fc.getSelectedFile();
            //System.out.print(selFile);
            if (selFile!=null){
	            
	            //System.out.print(selFile.getName());
	            String extension = selFile.getName().substring( (int)(selFile.getName().length()-4), (int)(selFile.getName().length()));
	            //System.out.print(extension + "\n");
	            //	System.out.print(selFile.getName().substring(0, (int)(selFile.getName().length()-4)));
	      
	      
	            if (extension.equals(".zip" )) {
		    	   System.out.print("opening file" + "\n");
		  	    	  String db_name = selFile.getName().substring(0, (int)(selFile.getName().length()-4));
		  	    	  unzip_webpage (selFile.getAbsolutePath(), "./" + db_name + "/");
		  	    	  Webpage_name = db_name;
		  	    	  try {
		  	    		  db = new WebpageDB(Webpage_name);
		  	    	  } catch (Exception ex1) {
		  	    		  ex1.printStackTrace();    // could not start db
		  	    	  }
		  	    	  testdesignframe testframe = new testdesignframe(db);
		  	    	  testframe.show();
	            }
            }
        }       
    }

    public void itemStateChanged(ItemEvent e) {
        JMenuItem source = (JMenuItem)(e.getSource());
        String s = "Item event detected."
                   + newline
                   + "    Event source: " + source.getText()
                   + " (an instance of " + getClassName(source) + ")"
                   + newline
                   + "    New state: "
                   + ((e.getStateChange() == ItemEvent.SELECTED) ?
                     "selected":"unselected");
        output.append(s + newline);
        output.setCaretPosition(output.getDocument().getLength());
    }

    // Returns just the class name -- no package info.
    protected String getClassName(Object o) {
        String classString = o.getClass().getName();
        int dotIndex = classString.lastIndexOf(".");
        return classString.substring(dotIndex+1);
    }

   /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static  void createAndShowGUI() {
        //Create and set up the window.
        frame = new JFrame("Webpage Builder Interface");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create/set menu bar and content pane.
        Interface demo = new Interface();
        frame.setJMenuBar(demo.createMenuBar());
        frame.setContentPane(demo.createContentPane());
        

        //Create and set up the popup menu.
        //demo.createPopupMenu();

        //Display the window.
        frame.setSize(600, 200);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private  void openPageDialog() {
        PageDialog pageD = new PageDialog();
        PageDialog.createAndShowGUI();
        
        testdesignframe testframe = new testdesignframe(db);
        testframe.show();
    }    
    
    

    static final int BUFFER = 2048;
      public static void zip_webpage(String input_directory, String output_filename) {
         try {
            BufferedInputStream origin = null;
            FileOutputStream dest = new
              FileOutputStream(output_filename+ ".zip");
            CheckedOutputStream checksum = new
              CheckedOutputStream(dest, new Adler32());
            ZipOutputStream out = new
              ZipOutputStream(new
                BufferedOutputStream(checksum));
            //out.setMethod(ZipOutputStream.DEFLATED);
            byte data[] = new byte[BUFFER];
            // get a list of files from current directory
            File f = new File(input_directory);
            String files[] = f.list();

            for (int i=0; i<files.length; i++) {
               System.out.println("Adding: "+files[i]);
               FileInputStream fi = new
                 FileInputStream(input_directory + "/" + files[i]);
               origin = new
                 BufferedInputStream(fi, BUFFER);
               ZipEntry entry = new ZipEntry(input_directory + "/" + files[i]);
               out.putNextEntry(entry); 
               int count;
               while((count = origin.read(data, 0,
                 BUFFER)) != -1) {
                  out.write(data, 0, count);
               }
               origin.close();
            }
            out.close();
            System.out.println("checksum: "+checksum.getChecksum().getValue());
         } catch(Exception e) {
            e.printStackTrace();
         }
      }

      public static void unzip_webpage (String input_file, String output_directory) {
      //output_directory : the location to unzip the files to.
    	  (new File(output_directory)).mkdir(); 
         try {
            final int BUFFER = 2048;
            BufferedOutputStream dest = null;
            FileInputStream fis = new
              FileInputStream(input_file);
            CheckedInputStream checksum = new
              CheckedInputStream(fis, new Adler32());
            ZipInputStream zis = new
              ZipInputStream(new
                BufferedInputStream(checksum));
            ZipEntry entry;
            while((entry = zis.getNextEntry()) != null) {
               System.out.println("Extracting: " +entry);
               int count;
               byte data[] = new byte[BUFFER];
               // write the files to the disk
               FileOutputStream fos = new
                 FileOutputStream(entry.getName());
               dest = new BufferedOutputStream(fos,
                 BUFFER);
               while ((count = zis.read(data, 0,
                 BUFFER)) != -1) {
                  dest.write(data, 0, count);
               }
               dest.flush();
               dest.close();
            }
            zis.close();
            System.out.println("Checksum: "+checksum.getChecksum().getValue());
         } catch(Exception e) {
            e.printStackTrace();
         }
      }    
    
    
      
      
      static public boolean deleteDirectory(File path) {
    	    if( path.exists() ) {
    	      File[] files = path.listFiles();
    	      for(int i=0; i<files.length; i++) {
    	         if(files[i].isDirectory()) {
    	           deleteDirectory(files[i]);
    	         }
    	         else {
    	           files[i].delete();
    	         }
    	      }
    	    }
    	    return( path.delete() );
      }
    
    public class ButtonPress implements ActionListener
	{
		private int value;

		public ButtonPress(int a)
		{
			value = a;
		}

		public void actionPerformed(ActionEvent arg0)
		{			
			if(this.value==1){
//				openPageDialog();
			}
			if(this.value==2){
				//thisis the run test button
			}
//			cv.repaint();
			
		}
	}
public static void ShowMessgaeBox(String msg) {
	 final Frame f = new Frame();
	 //f.setSize(300, 300);
	 f.setVisible (false);
	  


	 
      final JDialog jd = new JDialog (f, "Info", true);
      jd.setSize(300, 100);
      jd.setLayout (new GridLayout (0, 1));
      jd.setLocationRelativeTo(null);
      Label jl = new Label (msg); 
      jd.add (jl);

      JButton jb = new JButton ("OK");
      jd.add (jb);
      jb.addActionListener (new ActionListener() {
          public void actionPerformed (ActionEvent e) {
              jd.dispose();
              f.dispose();
            }
          });
      jd.pack();
      jd.setVisible(true);
	
}
    
}


