/*
 * Created by JFormDesigner on Tue Jan 05 14:18:57 EST 2010
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.sql.SQLException;

import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class LabCoordinatorframe extends JFrame {
	//Global Variables
	int labcoordinator_id;
	WebpageDB webDB = null;
	
	
	///////////////////////
	//
	//	Constructor
	//
	//	LabCoordinatorframe(WebpageDB db, int id)
	//	db: pass the WebpageDB which is being used
	//	id: the integer id of the LabCoordinator
	//		if -1 then this is a new LabCoordinator
	//
	public LabCoordinatorframe(WebpageDB db, int id) {
		webDB = db;
		labcoordinator_id = id;
		
		initComponents();
		
		//for labcoordinator_id!=-1 then we are viewing/editing the labcoordinator	
		//we need to set the field values from the database
		if( labcoordinator_id!=-1) {
			try {
				//"CREATE TABLE course( ID INTEGER IDENTITY, title VARCHAR(256), year VARCHAR(2),
				//department VARCHAR(2), course_number INTEGER, start_date DATE, end_date DATE, 
				//lecturer_id INTEGER, coordinator_id INTEGER, lab_coordinator_id INTEGER)");
				String name = webDB.query_single("select lab_coordinator_name from lab_coordinator where ID = " + labcoordinator_id).toString();
				String email = webDB.query_single("select lab_coordinator_email from lab_coordinator where ID = " + labcoordinator_id).toString();
				Object objPhone = webDB.query_single("select lab_coordinator_phone1 from lab_coordinator where ID = " + labcoordinator_id);
				if (objPhone!=null) {
					LabCoordinatorPhone1Field.setText(objPhone.toString());
				}
				objPhone = webDB.query_single("select lab_coordinator_phone2 from lab_coordinator where ID = " + labcoordinator_id);
				if (objPhone!=null) {
					LabCoordinatorPhone2Field.setText(objPhone.toString());
				}				
				LabCoordinatorNameField.setText(name);
				LabCoordinatorEmailField.setText(email);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
		}
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
	}



	///////////////////////
	//
	//	CheckCoordinatorData
	//
	//	check the values that are being entered for validity
	//
	private Boolean CheckCoordinatorData() {
		Boolean success= true;
		if (LabCoordinatorNameField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a name to proceed");
			success = false;
		}
		if (LabCoordinatorEmailField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter an email to proceed");
			success = false;
		}		

		return success;
		
	}
	
	///////////////////////
	//
	//	SaveButtonActionPerformed
	//
	//	Save the data from the form
	//	
	private void SaveButtonActionPerformed(ActionEvent e) {
		Boolean success= false;

		if (CheckCoordinatorData()) {
			//check for missing data
			if (labcoordinator_id==-1) {
				//insert
				try {
					String fields = "";
					String values = "";
					if (!LabCoordinatorPhone1Field.getText().isEmpty()) {
						fields += ", lab_coordinator_phone1";
						values += ", '" + LabCoordinatorPhone1Field.getText() + "'";
					}
					if (!LabCoordinatorPhone2Field.getText().isEmpty()) {
						fields += ", lab_coordinator_phone2";
						values += ", '" + LabCoordinatorPhone2Field.getText() + "'";
					}
					webDB.update("INSERT INTO lab_coordinator(lab_coordinator_name, lab_coordinator_email" + fields + ") VALUES('" + LabCoordinatorNameField.getText() + "', '" + LabCoordinatorEmailField.getText() + "'" + values + ")");
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				success = true;
			} else {
				//update
				try {
					String update_fields = "";
					if (!LabCoordinatorPhone1Field.getText().isEmpty()) {
						update_fields += ", lab_coordinator_phone1 = '" + LabCoordinatorPhone1Field.getText() + "'";
					}
					if (!LabCoordinatorPhone2Field.getText().isEmpty()) {
						update_fields += ", lab_coordinator_phone2 = '" + LabCoordinatorPhone2Field.getText() + "'";
					}
					webDB.update("UPDATE lab_coordinator set lab_coordinator_name = '" + LabCoordinatorNameField.getText() + "', lab_coordinator_email = '" + LabCoordinatorEmailField.getText() + "'" + update_fields + " where id = " + labcoordinator_id );
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				success = true;
			}
		}
		if (success) {
			this.setVisible(false);
			this.dispose();
		}
	}

	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		label1 = new JLabel();
		LabCoordinatorNameField = new JTextField();
		label2 = new JLabel();
		LabCoordinatorEmailField = new JTextField();
		label3 = new JLabel();
		LabCoordinatorPhone1Field = new JTextField();
		label4 = new JLabel();
		LabCoordinatorPhone2Field = new JTextField();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Lab Coordinator");
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(Borders.DIALOG_BORDER);
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new FormLayout(
					"19dlu, $lcgap, 23dlu, $lcgap, 83dlu, 3*($lcgap, default)",
					"3*(default, $lgap), default"));

				//---- label1 ----
				label1.setText("Name");
				label1.setHorizontalAlignment(SwingConstants.CENTER);
				contentPanel.add(label1, cc.xywh(1, 1, 3, 1));
				contentPanel.add(LabCoordinatorNameField, cc.xywh(5, 1, 7, 1));

				//---- label2 ----
				label2.setText("Email");
				label2.setHorizontalAlignment(SwingConstants.CENTER);
				contentPanel.add(label2, cc.xywh(1, 3, 3, 1));
				contentPanel.add(LabCoordinatorEmailField, cc.xywh(5, 3, 7, 1));

				//---- label3 ----
				label3.setText("Phone 1");
				label3.setHorizontalAlignment(SwingConstants.CENTER);
				contentPanel.add(label3, cc.xywh(1, 5, 3, 1));
				contentPanel.add(LabCoordinatorPhone1Field, cc.xywh(5, 5, 7, 1));

				//---- label4 ----
				label4.setText("Phone 2");
				label4.setHorizontalAlignment(SwingConstants.CENTER);
				contentPanel.add(label4, cc.xywh(1, 7, 3, 1));
				contentPanel.add(LabCoordinatorPhone2Field, cc.xywh(5, 7, 7, 1));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
				buttonBar.setLayout(new FormLayout(
					"$glue, $button, $rgap, $button",
					"pref"));

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, cc.xy(2, 1));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, cc.xy(4, 1));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JLabel label1;
	private JTextField LabCoordinatorNameField;
	private JLabel label2;
	private JTextField LabCoordinatorEmailField;
	private JLabel label3;
	private JTextField LabCoordinatorPhone1Field;
	private JLabel label4;
	private JTextField LabCoordinatorPhone2Field;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
