package WebBuilder;

import java.io.*;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.text.DateFormatSymbols;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Locale;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class WebBuilder {
	private String builder_parent_directory = "C:\\Documents and Settings\\Guy Mann\\workspace\\PhysicsApplets\\builder\\";	
	private String CSS_file = "";
	private String input_directory = builder_parent_directory + "input\\";
	private String output_directory = builder_parent_directory + "output\\";
	/**
	 * @param args
	 */
	public  void main(String[] args) {
		
		//create_personal_schedule_html();
		
		
		Document XML_doc =  process_xml(input_directory, "web_script.xml");
		//Document XML_doc =  process_xml(builder_parent_directory + "input\\scheduletest.xml");
		if (create_webpage(XML_doc)) {
			System.out.println("website creation success");
			
		} else {
			System.out.println("website creation failure");
		}
	 }
	
	public Document process_xml(String inDirectory, String XML_doc_file) {
		//builder_parent_directory = parent_directory;
		input_directory = inDirectory;
		output_directory = "./HTML/";
		boolean success = (new File(output_directory)).mkdir();
		if (!success) {
		    System.out.print("html output directory creation failed");
		}
		  try {
			  File file = new File(XML_doc_file);
			  DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			  DocumentBuilder db = dbf.newDocumentBuilder();
			  Document doc = db.parse(file);
			  doc.getDocumentElement().normalize();

			  System.out.println("Root element " + doc.getDocumentElement().getNodeName());
			  
				NodeList findCSSLst = doc.getDocumentElement().getChildNodes();
				for (int q = 0; q < findCSSLst.getLength(); q++) {
					if (findCSSLst.item(q).getNodeName().equals("CSS")) { CSS_file= findCSSLst.item(q).getFirstChild().getNodeValue();}
				}
			  
			  NodeList nodeLst = doc.getElementsByTagName("page");
			  System.out.println("Information of all pages");

			  for (int s = 0; s < nodeLst.getLength(); s++) {

			    Node fstNode = nodeLst.item(s);
			    
			    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
			    	Element output_filename = doc.createElement("output_filename");
			    	if (is_frontpage( fstNode)) {
			    		output_filename.appendChild(doc.createTextNode("index.html"));
			    	} else {
					      Element fstElmnt = (Element) fstNode;
					      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("name");
					      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
					      NodeList fstNm = fstNmElmnt.getChildNodes();	
			    		output_filename.appendChild(doc.createTextNode(((Node) fstNm.item(0)).getNodeValue() + ".html"));
			    	}
			      
			    	nodeLst.item(s).appendChild(output_filename);
			    }

			  }
			  return doc;
/*			  for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("name");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      System.out.println("Name : "  + ((Node) fstNm.item(0)).getNodeValue());
				      NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("html_file_content");
				      Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
				      NodeList lstNm = lstNmElmnt.getChildNodes();
				      System.out.println("Content Location : " + ((Node) lstNm.item(0)).getNodeValue());
				      
				      NodeList output_NmElmntLst = fstElmnt.getElementsByTagName("output_filename");
				      Element output_NmElmnt = (Element) output_NmElmntLst.item(0);
				      NodeList output_Nm = output_NmElmnt.getChildNodes();
				      System.out.println("output filename: " + ((Node) output_Nm.item(0)).getNodeValue());		      
				    }

			  }*/
			  
		  } catch (Exception e) {
		    e.printStackTrace();
		    return null;
		  }
		  
		
	}
	public boolean create_webpage(Document XML_doc) {

		String header_html = "";
		String footer_html = "";
		
		//check for file existance here before moving
		try {
			copy(new File(input_directory + CSS_file ), new File(output_directory + CSS_file ) );
	    }catch (Exception e){//Catch exception if any
	    	System.err.println("Error: " + e.getMessage());
	    }
		///////////////////////////////////////////////////
		//
		//	HEADER CREATION
		//  	    
		//process header
		  NodeList header_nodeLst = XML_doc.getElementsByTagName("header");
		  if (header_nodeLst.getLength() >1){
			  return false;
		  } else {
			    Node fstNode = header_nodeLst.item(0);
			    header_html =  create_html(fstNode, XML_doc);
				System.out.println(header_html);
		  }

		///////////////////////////////////////////////////
		//
		//	FOOTER CREATION
		//  
		//process footer
		  NodeList footer_nodeLst = XML_doc.getElementsByTagName("footer");
		  if (footer_nodeLst.getLength() >1){
			  return false;
		  } else {
			    Node fstNode = footer_nodeLst.item(0);

			    footer_html =  create_html(fstNode, XML_doc);
				
				//System.out.println(footer_html);
			  
		  }
		  
		///////////////////////////////////////////////////
		//
		//	PAGE CREATION
		//  
		//traverse pages and create each based on output_filename 
		  NodeList nodeLst = XML_doc.getElementsByTagName("page");

		  for (int s = 0; s < nodeLst.getLength(); s++) {
			  String page_html = "";
			  String temp_html = ""; 
			  Node fstNode = nodeLst.item(s);
			  page_html =  create_html(fstNode, XML_doc);

			  temp_html =  "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
			  temp_html = temp_html + "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n<head>";
			  temp_html = temp_html + "<title>" + find_title_for_page(fstNode) + "</title>";
			  temp_html = temp_html + "<link rel=\"stylesheet\" media=\"all\" type=\"text/css\" href=\"" + CSS_file + "\" />\n</head>";			  
			  temp_html = temp_html + "<body>\n<div id=\"container\">\n<div id=\"content\">" + header_html;
			  temp_html = temp_html + page_html + footer_html + "</div>\n</div>\n</body>";
			  page_html = temp_html;  
			  //System.out.println(page_html);
			  
			   String output_file = find_outputname_for_page(fstNode);
			  //output_directory
			   try{
		    	    // Create file 
		    	    FileWriter fstream = new FileWriter(output_directory + output_file);
		    	        BufferedWriter out = new BufferedWriter(fstream);
		    	    out.write(page_html);
		    	    //Close the output stream
		    	    out.close();
	    	    }catch (Exception e){//Catch exception if any
	    	    	System.err.println("Error: " + e.getMessage());
	    	    }
			   
		  }
		  
		  
		return true;
	}
	private Node find_page_by_name(String page_name, Document XML_doc)
	{
		  NodeList nodeLst = XML_doc.getElementsByTagName("page");
		  for (int s = 0; s < nodeLst.getLength(); s++) {

			    Node fstNode = nodeLst.item(s);
			    
			    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
			  
			      Element fstElmnt = (Element) fstNode;
			      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("name");
			      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
			      NodeList fstNm = fstNmElmnt.getChildNodes();
			      if (((Node) fstNm.item(0)).getNodeValue().equals(page_name)) {
			    	return   fstNode;
			    	  
			      }		      
			    }

		   }
		
		return null;
	}
	
	private  String find_outputname_for_page(Node pageNode)
	{
			  
			      Element fstElmnt = (Element) pageNode;
			      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("output_filename");
			      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
			      NodeList fstNm = fstNmElmnt.getChildNodes();
			    	return    fstNm.item(0).getNodeValue();
	}
	private  String find_title_for_page(Node pageNode)
	{
			  
			      Element fstElmnt = (Element) pageNode;
			      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("title");
			      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
			      NodeList fstNm = fstNmElmnt.getChildNodes();
			    	return    fstNm.item(0).getNodeValue();
	}
	private  String find_menu_title_for_page(Node pageNode)
	{
	      Element fstElmnt = (Element) pageNode;
	      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("menu_title");
	      if (fstNmElmntLst.getLength()>0)
	      {
		      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
		      NodeList fstNm = fstNmElmnt.getChildNodes();
		      return    fstNm.item(0).getNodeValue();
	      } else {
			      Element titleElmnt = (Element) pageNode;
			      NodeList titleElmntLst = titleElmnt.getElementsByTagName("title");
			      Element fstNmElmnt = (Element) titleElmntLst.item(0);
			      NodeList fstNm = fstNmElmnt.getChildNodes();
			      return    fstNm.item(0).getNodeValue();
	      }
	}	
	private  boolean is_frontpage(Node SrchNode)
	{
    	NodeList findfrontLst = SrchNode.getChildNodes();
    	for (int q = 0; q < findfrontLst.getLength(); q++) {
    		if (findfrontLst.item(q).getNodeName().equals("frontpage")) { return true;}
    	}
		return false;
	}
	
	//deals with parding the pages 
	private String create_html(Node html_Node, Document XML_doc)
	{
		
		String return_string = "";
		 
	    NodeList headerLst = html_Node.getChildNodes();
		for (int s = 0; s < headerLst.getLength(); s++) {
			
		   Node subhd_Node = headerLst.item(s);
		   
		   //System.out.println("NAME: " + subhd_Node.getNodeName());
		   
		   //System.out.println("VALUE: " + subhd_Node.getNodeValue());
		   if (subhd_Node.getNodeName().equals("img_content")) {
			   //<src>banner.gif</src>"
				//<alt_text>WPI Physics Department
				//<align>middle</align>
				//<height>60</height>
				//<width>465</with>
			   //update in here
			   return_string = return_string + "<img ";
			   NodeList imageLst = subhd_Node.getChildNodes();
			   for (int t = 0; t < imageLst.getLength(); t++) {
				   Node sub_image_item_Node = imageLst.item(t);
				   //System.out.println(submn_Node.getNodeName());
				   if (sub_image_item_Node.getNodeName() == "src") {
					   return_string = return_string + "src=\"" + sub_image_item_Node.getFirstChild().getNodeValue() + "\" ";
					   
						try {
							copy(new File(input_directory + sub_image_item_Node.getFirstChild().getNodeValue()  ), new File(output_directory + sub_image_item_Node.getFirstChild().getNodeValue() ) );
					    }catch (Exception e){//Catch exception if any
					    	System.err.println("Error: " + e.getMessage());
					    }	
				   }
				   if (sub_image_item_Node.getNodeName() == "alt_text") {
					   return_string = return_string + "alt=\"" + sub_image_item_Node.getFirstChild().getNodeValue() + "\" ";
				   }
				   if (sub_image_item_Node.getNodeName() == "align") {
					   return_string = return_string + "align=\"" + sub_image_item_Node.getFirstChild().getNodeValue() + "\" ";
				   }
				   if (sub_image_item_Node.getNodeName() == "height") {
					   return_string = return_string + "height=\"" + sub_image_item_Node.getFirstChild().getNodeValue() + "\" ";
				   }
				   if (sub_image_item_Node.getNodeName() == "width") {
					   return_string = return_string + "width=\"" + sub_image_item_Node.getFirstChild().getNodeValue() + "\" ";
				   }
			   }
			   return_string = return_string + ">\n";

		   }
		   
		   //HTML_FILE_CONTENT
		   if (subhd_Node.getNodeName().equals("html_file_content")) {
			   String content_location_value = subhd_Node.getFirstChild().getNodeValue();
			   System.out.println("content location Name : "  + content_location_value);				   
			   
			   try {
		        BufferedReader in = new BufferedReader(new FileReader(input_directory + content_location_value));
		        String str;
		        while ((str = in.readLine()) != null) {
		        	return_string  = return_string  + str + "\n";
		        }
		        in.close();    
		        } catch (IOException e) {
		        }
			    
		   }
		   //HTML_CONTENT
		   if (subhd_Node.getNodeName().equals("html_content")) {
			   String html_content_value = subhd_Node.getFirstChild().getNodeValue();
			   String temp_string = "";
			   temp_string  = html_content_value.replace("[", "<");
			   return_string  =  return_string + temp_string.replace("]", ">");
			   System.out.println("html content value : "  + html_content_value);
		   }	
		   
		   //PSERONAL SCHEDULE
		   if (subhd_Node.getNodeName().equals("personal_sched")) {
			   String schedule_html = "";
			   schedule_html = create_personal_schedule_html(subhd_Node.getFirstChild().getNodeValue());
			   return_string  = return_string  + schedule_html;
		   }	
		   if (subhd_Node.getNodeName().equals("applet_content")) {
	       		//<src>VectorTest2.class</src>
	       		//<type>class</type>
	       		//<height>432</height>
				//<width>510</width>
			   String width = "" ;
			   String height = "";
			   String type = "";
			   String code = "";
			   String applet_src = "";
			   //update in here
			   
			   NodeList imageLst = subhd_Node.getChildNodes();
			   for (int t = 0; t < imageLst.getLength(); t++) {
				   Node sub_image_item_Node = imageLst.item(t);
				   //System.out.println(submn_Node.getNodeName());
				   if (sub_image_item_Node.getNodeName() == "src") {
					   applet_src = sub_image_item_Node.getFirstChild().getNodeValue();					   
						try {
							copy(new File(input_directory + applet_src  ), new File(output_directory + applet_src) );
					    }catch (Exception e){//Catch exception if any
					    	System.err.println("Error: " + e.getMessage());
					    }	
				   }
				   if (sub_image_item_Node.getNodeName() == "code") {
					   code = sub_image_item_Node.getFirstChild().getNodeValue();		
				   }
				   if (sub_image_item_Node.getNodeName() == "type") {
					   type = sub_image_item_Node.getFirstChild().getNodeValue();
				   }
				   if (sub_image_item_Node.getNodeName() == "height") {
					   height = sub_image_item_Node.getFirstChild().getNodeValue();
				   }
				   if (sub_image_item_Node.getNodeName() == "width") {
					   width = sub_image_item_Node.getFirstChild().getNodeValue();
				   }
			   }
			   
			   return_string = return_string + "<APPLET ";
			   if (type.equals("class"))
			   {
				   
				   return_string = return_string + "CODE=\"" + applet_src + "\" ";
				   
				   if (!width.isEmpty()) {
					   return_string = return_string + "WIDTH=\"" + width + "\" ";   
				   }
				   if (!height.isEmpty()) {
					   return_string = return_string + "HEIGHT=\"" + width + "\" ";   
				   }
				   				   
			   }
			   if (type.equals("archive"))
			   {
//				   <Applet CODE="phyApps.StatsImporter" ARCHIVE="StatsImporter.jar" width=800 Height=800>
//				   </Applet>
				   return_string = return_string + "ARCHIVE=\"" + applet_src + "\" ";
				   return_string = return_string + "CODE=\"" + code + "\" ";
				   
				   if (!width.isEmpty()) {
					   return_string = return_string + "WIDTH=\"" + width + "\" ";   
				   }
				   if (!height.isEmpty()) {
					   return_string = return_string + "HEIGHT=\"" + width + "\" ";   
				   }
			   }
			   return_string = return_string + ">\n<HR>\nIf you can see this text (instead of the applet that\"s supposed to be here), it means your browser is not Java-enabled.\n<HR>";
			   return_string = return_string + "</APPLET>";			   
		   }		   
		   
		   if (subhd_Node.getNodeName().equals("file_link")) {
			   //<name>Hot Wheels Energy Experiment</name>
			   //<src>IQP Final.mp4</src>	
			   String file_link_name = "";
			   String file_link_src = "";
			   NodeList imageLst = subhd_Node.getChildNodes();
			   for (int t = 0; t < imageLst.getLength(); t++) {
				   Node sub_image_item_Node = imageLst.item(t);
				   //System.out.println(submn_Node.getNodeName());
				   if (sub_image_item_Node.getNodeName() == "src") {
					   file_link_src = sub_image_item_Node.getFirstChild().getNodeValue();
					   //return_string = return_string + "src=\"" +  + "\" ";
					   
						try {
							copy(new File(input_directory + file_link_src  ), new File(output_directory + file_link_src ) );
					    }catch (Exception e){//Catch exception if any
					    	System.err.println("Error: " + e.getMessage());
					    }	
				   }
				   if (sub_image_item_Node.getNodeName() == "name") {
					   file_link_name = sub_image_item_Node.getFirstChild().getNodeValue();
					   //return_string = return_string + "alt=\"" +  + "\" ";
				   }
				   
			   }
			   return_string =  return_string + "<a href=\"" + file_link_src + "\">" + file_link_name + "</a>\n<br>\n";

		   }
		   
		   //MENU
		   if (subhd_Node.getNodeName().equals("menu")) {
			   String menu_html = "";
			   String menu_class = null;
			   NodeList menuLst = subhd_Node.getChildNodes();
			   for (int t = 0; t < menuLst.getLength(); t++) {
				   Node submnitem_Node = menuLst.item(t);
				   //System.out.println(submn_Node.getNodeName());
				   if (submnitem_Node.getNodeName() == "css_class") {
					   menu_class = submnitem_Node.getFirstChild().getNodeValue();
					   System.out.println("Menu Class : "  + menu_class);
				   }

			   }			   
			   
			   
			   menu_html = menu_html + "<ul class=\"" + menu_class + "\">\n";
			   menu_html = menu_html + create_menu_html(subhd_Node, XML_doc);
			   menu_html = menu_html + "</ul>\n";
			
			   return_string  = return_string  + menu_html;
		   }
		   
		   //COURSE_SCHEDULE
		   if (subhd_Node.getNodeName().equals("course_schedule")) {
			   String schedule_html = "";
			   schedule_html = create_schedule_html(subhd_Node, XML_doc);
			   return_string  = return_string  + schedule_html;
		   }			   
		}
		return return_string; 
	}


	
	private  String create_schedule_html(Node sched_Node, Document XML_doc)
	{
//	       <start_date>2009-08-27</start_date>
//	       <end_date>2009-10-15</end_date>		
	   String sched_html = "";
	   String lecturer_html = "";
	   String coordinator_html = "";
	   String lab_coordinator_html = "";
	   String lab_instructor1_html = "";
	   String lab_instructor2_html = "";
	   String title = "";
	   //String start_date = "";
	   Calendar start_date = Calendar.getInstance(Locale.US);
	   //String end_date = "";
	   Calendar end_date = Calendar.getInstance(Locale.US);
	   DateFormatSymbols dfs = new DateFormatSymbols(Locale.US);
	   ArrayList<ArrayList<String>> event_array = new ArrayList<ArrayList<String>>();
	   String[] months = dfs.getMonths();
	   int event_count = 0;
	   
	   NodeList sched_Lst = sched_Node.getChildNodes();
	   for (int t = 0; t < sched_Lst.getLength(); t++) {
		   Node scheditem_Node = sched_Lst.item(t);
		   //System.out.println(submn_Node.getNodeName());
		   if (scheditem_Node.getNodeName() == "title") {
			   title += scheditem_Node.getFirstChild().getNodeValue();
		   }
		   if (scheditem_Node.getNodeName() == "lecturer") {
			   String name = "";
			   String email = "";
			   String phone1 = "";
			   String phone2 = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "name") {
					   name = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "email") {
					   email = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone1") {
					   phone1 = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone2") {
					   phone2 = dateitem_Node.getFirstChild().getNodeValue();
				   }				   
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("lecturer: "  + name + " " + email + " " + phone1 + " " + phone2);
			   lecturer_html = name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)";
			   if (!phone1.isEmpty()) {
				   lecturer_html += " " + phone1;
			   
			   }
			   if (!phone2.isEmpty()) {
				   lecturer_html += " " + phone2;
			   }
			   lecturer_html += "<br>\n";
		   }		   
		   if (scheditem_Node.getNodeName() == "coordinator") {
			   String name = "";
			   String email = "";
			   String phone1 = "";
			   String phone2 = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "name") {
					   name = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "email") {
					   email = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone1") {
					   phone1 = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone2") {
					   phone2 = dateitem_Node.getFirstChild().getNodeValue();
				   }				   
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("coordinator: "  + name + " " + email + " " + phone1 + " " + phone2);
			   coordinator_html = name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)";
			   if (!phone1.isEmpty()) {
				   coordinator_html += " " + phone1;
			   
			   }
			   if (!phone2.isEmpty()) {
				   coordinator_html += " " + phone2;
			   }
			   coordinator_html += "<br>\n";
		   }
		   if (scheditem_Node.getNodeName() == "lab_coordinator") {
			   String name = "";
			   String email = "";
			   String phone1 = "";
			   String phone2 = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "name") {
					   name = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "email") {
					   email = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone1") {
					   phone1 = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "phone2") {
					   phone2 = dateitem_Node.getFirstChild().getNodeValue();
				   }				   
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("lab_coordinator: "  + name + " " + email + " " + phone1 + " " + phone2);
			   lab_coordinator_html = name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)";
			   if (!phone1.isEmpty()) {
				   lab_coordinator_html += " " + phone1;
			   
			   }
			   if (!phone2.isEmpty()) {
				   lab_coordinator_html += " " + phone2;
			   }
			   lab_coordinator_html += "<br>\n";
		   }
		   if (scheditem_Node.getNodeName() == "lab_instructor1") {
			   String name = "";
			   String email = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "name") {
					   name = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "email") {
					   email = dateitem_Node.getFirstChild().getNodeValue();
				   }
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("lab_instructor1: "  + name + " " + email);
			   lab_instructor1_html = name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)";
			   lab_instructor1_html += "<br>\n";
		   }	
		   if (scheditem_Node.getNodeName() == "lab_instructor2") {
			   String name = "";
			   String email = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "name") {
					   name = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "email") {
					   email = dateitem_Node.getFirstChild().getNodeValue();
				   }		   
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("lab_instructor2: "  + name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)");
			   lab_instructor2_html = name + " (<a href=\"mailto:" + email + "\">" + email + "</a>)";
			   lab_instructor2_html += "<br>\n";
		   }		   
		   if (scheditem_Node.getNodeName() == "start_date") {
			   String yr = "";
			   String mn = "";
			   String dy = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "year") {
					   yr = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "day") {
					   dy = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "month") {
					   mn = dateitem_Node.getFirstChild().getNodeValue();
				   }
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
			   System.out.println("start date: "  + yr + "-" + mn + "-" + dy);
			   start_date.set(Integer.parseInt(yr), Integer.parseInt(mn)-1, Integer.parseInt(dy));
		   }
		   if (scheditem_Node.getNodeName() == "end_date") {
			   String yr = "";
			   String mn = "";
			   String dy = "";
			   NodeList date_Lst = scheditem_Node.getChildNodes();
			   for (int s = 0; s < date_Lst.getLength(); s++) {
				   Node dateitem_Node = date_Lst.item(s);
				   if (dateitem_Node.getNodeName() == "year") {
					   yr = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "day") {
					   dy = dateitem_Node.getFirstChild().getNodeValue();
				   }
				   if (dateitem_Node.getNodeName() == "month") {
					   mn = dateitem_Node.getFirstChild().getNodeValue();
				   }
			   }
//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
//				   System.out.println("start date: "  + start_date);
			   System.out.println("start date: "  + yr + "-" + mn + "-" + dy);
			   end_date.set(Integer.parseInt(yr), Integer.parseInt(mn)-1, Integer.parseInt(dy));
		   }
		   if (scheditem_Node.getNodeName() == "event") {
			   //event_array[n][0]: name
			   //event_array[n][1]: year
			   //event_array[n][2]: month
			   //event_array[n][3]: day
			   //event_array[n][4]: time
			   //event_array[n][5]: type
			   //event_array[n][6]: tag
			   //event_array[n][7]: lab_doc_html
			   event_array.add(new ArrayList<String>());
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   event_array.get(event_array.size()-1).add("");
			   //need to loop here to store all the events to later chack
			   System.out.println("event" );
			   NodeList event_Lst = scheditem_Node.getChildNodes();
			   for (int r = 0; r < event_Lst.getLength(); r++) {
				   Node eventitem_Node = event_Lst.item(r);
				   if (eventitem_Node.getNodeName() == "name") {
					   event_array.get(event_array.size()-1).set(0, eventitem_Node.getFirstChild().getNodeValue());
				   }
				   if (eventitem_Node.getNodeName() == "type") {
					   event_array.get(event_array.size()-1).set(5, eventitem_Node.getFirstChild().getNodeValue());
				   }				   
				   if (eventitem_Node.getNodeName() == "time") {
					   event_array.get(event_array.size()-1).set(4, eventitem_Node.getFirstChild().getNodeValue());
				   }				
				   
				   if (eventitem_Node.getNodeName().equals("file_link")) {
					   // check if file exists
					   // if the file doesn't exist already copy it
					   // add it to an array of files and urls and add it to the event_array (it will have to be traversed later)
					   
					   
					   //<name>Hot Wheels Energy Experiment</name>
					   //<src>IQP Final.mp4</src>	
					   String file_link_name = "";
					   String file_link_src = "";
					   NodeList imageLst = eventitem_Node.getChildNodes();
					   for (int w = 0; w < imageLst.getLength(); w++) {
						   Node sub_image_item_Node = imageLst.item(w);
						   //System.out.println(submn_Node.getNodeName());
						   if (sub_image_item_Node.getNodeName() == "src") {
							   file_link_src = sub_image_item_Node.getFirstChild().getNodeValue();
							   //return_string = return_string + "src=\"" +  + "\" ";
							   
								try {
									copy(new File(input_directory + file_link_src  ), new File(output_directory + file_link_src ) );
							    }catch (Exception e){//Catch exception if any
							    	System.err.println("Error: " + e.getMessage());
							    }	
						   }
						   if (sub_image_item_Node.getNodeName() == "name") {
							   file_link_name = sub_image_item_Node.getFirstChild().getNodeValue();
							   //return_string = return_string + "alt=\"" +  + "\" ";
						   }
						   
					   }
					   event_array.get(event_array.size()-1).set(7, event_array.get(event_array.size()-1).get(7) +"<a href=\"" + file_link_src + "\">" + file_link_name + "</a>  ");
					    
				   }
				   if (eventitem_Node.getNodeName().equals("external_link")) {
					   // add it to an array of files and urls and add it to the event_array (it will have to be traversed later)

					   
					   //<name>Hot Wheels Energy Experiment</name>
					   //<src>IQP Final.mp4</src>	
					   String file_link_name = "";
					   String file_link_src = "";
					   NodeList imageLst = eventitem_Node.getChildNodes();
					   for (int d = 0; d < imageLst.getLength(); d++) {
						   Node sub_image_item_Node = imageLst.item(d);
						   //System.out.println(submn_Node.getNodeName());
						   if (sub_image_item_Node.getNodeName() == "src") {
							   file_link_src = sub_image_item_Node.getFirstChild().getNodeValue();
						   }
						   if (sub_image_item_Node.getNodeName() == "name") {
							   file_link_name = sub_image_item_Node.getFirstChild().getNodeValue();
						   }
						   
					   }
					   event_array.get(event_array.size()-1).set(7, event_array.get(event_array.size()-1).get(7) +"<a href=\"" + file_link_src + "\">" + file_link_name + "</a>  ");
				   }				   
				   if (eventitem_Node.getNodeName() == "date") {
					   NodeList date_Lst = eventitem_Node.getChildNodes();
					   for (int s = 0; s < date_Lst.getLength(); s++) {
						   Node dateitem_Node = date_Lst.item(s);
						   if (dateitem_Node.getNodeName() == "year") {
							   event_array.get(event_array.size()-1).set(1, dateitem_Node.getFirstChild().getNodeValue());
						   }
						   if (dateitem_Node.getNodeName() == "day") {
							   event_array.get(event_array.size()-1).set(3, dateitem_Node.getFirstChild().getNodeValue());
						   }
						   if (dateitem_Node.getNodeName() == "month") {
							   event_array.get(event_array.size()-1).set(2, dateitem_Node.getFirstChild().getNodeValue());
						   }
					   }
		//				   start_date = scheditem_Node.getFirstChild().getNodeValue();
		//				   System.out.println("start date: "  + start_date);
				   }
			   }
			   event_array.get(event_array.size()-1).set(6,"event" + event_count);
			   System.out.println("event: " + event_array.get(event_array.size()-1).get(0) + " date: "  + event_array.get(event_array.size()-1).get(1) + "-" + event_array.get(event_array.size()-1).get(2) + "-" + event_array.get(event_array.size()-1).get(3));
			   System.out.println("time: " + event_array.get(event_array.size()-1).get(4));
			   System.out.println("docs: " + event_array.get(event_array.size()-1).get(7));
			   event_count = event_count+1;
		   }			   
	   }		
	   
	   
	   sched_html += "<h2>" + title + "</h2><br>\n";
		sched_html = sched_html + "Lecturer: " + lecturer_html;
		if (!coordinator_html.isEmpty()) {
			sched_html = sched_html + "Coordinator: " + coordinator_html;
		}
		sched_html = sched_html + "Lab Coordinator: " + lab_coordinator_html;
		sched_html = sched_html + "Primary Lab Instructor: " + lab_instructor1_html;
		if (!lab_instructor2_html.isEmpty()) {
			sched_html = sched_html + "Backup Lab Instructor: " + lab_instructor2_html;
		}
		sched_html = sched_html + "<br>\n";
		
	   Calendar cal_end_date = end_date;
	   cal_end_date.add(Calendar.DATE,1);
	   Calendar cal_start_date = start_date;
	   cal_start_date.add(Calendar.DATE,-1);	   
	   int end_month = end_date.get(Calendar.MONTH);
	   int start_month = start_date.get(Calendar.MONTH);
	   System.out.println("start month: " + start_month );
	   if ( end_month < start_month ) 
	   {
		   end_month = end_month+12;
	   }
	   int month_diff = end_month - start_month;
	   System.out.println("month_diff: " + month_diff );
	   sched_html = sched_html + "<TABLE BORDER=0 CELLSPACING=3 CELLPADDING=3>\n";
	   sched_html = sched_html + "<TR>\n";
	   for (int k = 0; k <= month_diff; k++) {
		   //set the counter date which will be traversed to show the dates in the term
		   int counter_month = start_date.get(Calendar.MONTH) + k;
		   int counter_year = start_date.get(Calendar.YEAR);
		   if ( counter_month >12)
		   {
			   counter_month = counter_month - 12;
			   counter_year = counter_year + 1;
			   
		   }
		   Calendar counter_date = Calendar.getInstance(Locale.US);
		   counter_date.set(counter_year, counter_month, 1);
		   
		   sched_html = sched_html + "<TD>\n";
			// fill table with empty cells for days
			sched_html = sched_html + "<TABLE BORDER=3 CELLSPACING=3 CELLPADDING=3 style=\"empty-cells: hide\">\n";
			sched_html = sched_html + "<TR>\n";
			sched_html = sched_html + "<TD COLSPAN=\"7\" ALIGN=center><B>";
			
			sched_html = sched_html + months[counter_date.get(Calendar.MONTH)] + " " + counter_date.get(Calendar.YEAR);
			 
			sched_html = sched_html + "</B></TD>\n";
			sched_html = sched_html + "</TR>\n";

			sched_html = sched_html + "<TR>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Sun</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Mon</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Tue</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Wed</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Thu</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Fri</font></TD>\n";
			sched_html = sched_html + "<TD ALIGN=center><font size=\"-2\">Sat</font></TD>\n";
			sched_html = sched_html + "</TR>\n";

			System.out.println("MONTH: " + counter_date.get(Calendar.MONTH) );
			//System.out.println("month start Day_Of_week: " + counter_date.get(Calendar.DAY_OF_WEEK) );
			//has the start of term been passed
			boolean show_date = false;
			int last_date = 0;
			for (int i = 0; i < 6; i++) {
				sched_html = sched_html + "<TR height=\"20\">\n";					
			    for (int j = 0; j < 7; j++) {

			    	sched_html = sched_html + "<TD ALIGN=center height =\"20\">";
			    	if (i==0 && !show_date) {
			    		//			    		Calendar.DAY_OF_WEEK
				    	//int day_of_week = j;
				    	//day_of_week = day_of_week+1;
				    	//System.out.println("Day_Of_week: " + day_of_week );
				    	//System.out.println("counter Day_Of_week: " +counter_date.get(Calendar.DAY_OF_WEEK));
				    	
			    		if (j+1>=counter_date.get(Calendar.DAY_OF_WEEK) )
			    		{
			    			show_date = true;
			    			//System.out.println("past start of month");
			    			//System.out.println("Day_Of_week: " + day_of_week );
			    		}				    		
			    	}
		    		if (last_date > counter_date.get(Calendar.DATE) && show_date)
		    		{
		    			show_date = false;		    			
		    		}
			    	if (show_date )
			    	{	
				    	if (counter_date.before(cal_end_date) && counter_date.after(cal_start_date))
				    	{
				    		
///<TD ALIGN=center style='background-color: rgb(102, 255, 255)'>				    		
				    		//
				    		//check here for any events on this date in order to link to them
				    		int EventIndex = check_for_event_in_event_array(counter_date,  event_array);
				    		if (EventIndex>=0) {
				    			sched_html = sched_html + "<a href=\"#" + event_array.get(EventIndex).get(6) + "\">"; 	
				    		}
				    		sched_html = sched_html + counter_date.get(Calendar.DATE);
				    		if (EventIndex>=0) {
				    			sched_html = sched_html + "</a>"; 	
				    		}				    		
				    		last_date = counter_date.get(Calendar.DATE);
				    	}
				    	counter_date.add(Calendar.DATE, 1);
			    	}
			    	sched_html = sched_html + "</TD>\n";
			    	

			    }
				sched_html = sched_html + "</TR>\n";				    
			}
			sched_html = sched_html + "</TABLE>\n";
			sched_html = sched_html + "</TD>\n";
			
	   }
		sched_html = sched_html + "</TR>\n</TABLE>\n";
		sched_html = sched_html + "<br><br>\n";
		
		for (int q = 0; q < event_array.size(); q++) {
			if (event_array.get(q).get(6).length()>0) {
				sched_html = sched_html + "<a name=\"" + event_array.get(q).get(6) + "\">";	
			}
			sched_html = sched_html + event_array.get(q).get(0) ;
			if (event_array.get(q).get(6).length()>0) {
				sched_html = sched_html + "</a>";	
			}			
			
			sched_html = sched_html + " - " +  event_array.get(q).get(2) + "/" + event_array.get(q).get(3) + "/" + event_array.get(q).get(1);
			sched_html = sched_html + "- " + event_array.get(q).get(4) + "<br>" + event_array.get(q).get(7) + "<br><br>\n\n";
			System.out.println("event: " + event_array.get(q).get(0) + " date: "  + event_array.get(q).get(1) + "-" + event_array.get(q).get(2) + "-" + event_array.get(q).get(3));
			System.out.println("time: " + event_array.get(q).get(4));
		}
		
		
		
		return sched_html;
	}
	
	
	private String create_menu_html(Node menu_Node, Document XML_doc)
	{
		String return_string = "";
	   String menu_html = "";			   

	   
	   ArrayList<ArrayList<String>> menu_array = new ArrayList<ArrayList<String>>();
	   NodeList groupLst = menu_Node.getChildNodes();
	   for (int t = 0; t < groupLst.getLength(); t++) {
		   Node submnitem_Node = groupLst.item(t);
		   //System.out.println(submn_Node.getNodeName());
//				   if (submnitem_Node.getNodeName() == "css_class") {
//					   menu_class = submnitem_Node.getFirstChild().getNodeValue();
//					   System.out.println("Menu Class : "  + menu_class);
//				   }
		   if (submnitem_Node.getNodeName() == "group") {
			   String group_html = "";
			   String group_class = "";
			   String group_name = "";
			   NodeList subgroupLst = submnitem_Node.getChildNodes();
			   for (int r = 0; r < subgroupLst.getLength(); r++) {
				   Node group_Node = subgroupLst.item(r);
				   if (group_Node.getNodeName() == "css_class") {
					   group_class = group_Node.getFirstChild().getNodeValue();
					   System.out.println("Group Class : "  + group_class);
				   }
				   if (group_Node.getNodeName() == "title") {
					   System.out.println("Group Name : "  + group_Node.getFirstChild().getNodeValue());
					   group_name = group_Node.getFirstChild().getNodeValue();
				   }
			   	
			   }
			   //create openning tag
			   group_html = group_html + "<li class=\"" + group_name + "\"" + "><a class=\""+ group_class + "\" href=\"#nogo\">\n";
			   group_html = group_html + group_name + "<!--[if IE 7]><!--></a><!--<![endif]-->\n<!--[if lte IE 6]><table><tr><td><![endif]-->\n<ul>\n";


			   
			   //then call this functino recursively with the Node
			   System.out.println(create_menu_html(submnitem_Node, XML_doc));
			   group_html = group_html + create_menu_html(submnitem_Node, XML_doc);
				
			   //add the closin g tag
			   group_html = group_html + "</ul>\n<!--[if lte IE 6]></td></tr></table></a><![endif]--></li>\n";


			   menu_array.add(new ArrayList<String>());
			   menu_array.get(menu_array.size()-1).add(group_html);
			   menu_array.get(menu_array.size()-1).add("group");					   
			   
			   
			   
		   }				   
		   if (submnitem_Node.getNodeName() == "menu_page") {
			   NodeList menupageLst = submnitem_Node.getChildNodes();
			   for (int r = 0; r < menupageLst.getLength(); r++) {
				   Node menupage_Node = menupageLst.item(r);
				   if (menupage_Node.getNodeName() == "name") {
					   System.out.println("Menu Page : "  + menupage_Node.getFirstChild().getNodeValue());
					   menu_array.add(new ArrayList<String>());
					   menu_array.get(menu_array.size()-1).add(menupage_Node.getFirstChild().getNodeValue());
					   menu_array.get(menu_array.size()-1).add("page");
				   }
			   	
			   }
		   }
		   if (submnitem_Node.getNodeName() == "file_link") {
			   String file_link_name = "";
			   String file_link_src = "";
			   NodeList flink_Lst = submnitem_Node.getChildNodes();
			   for (int r = 0; r < flink_Lst.getLength(); r++) {
				   Node flink_Node = flink_Lst.item(r);
				   if (flink_Node.getNodeName() == "name") {
					   file_link_name = flink_Node.getFirstChild().getNodeValue();
					   System.out.println("file link source: "  + flink_Node.getFirstChild().getNodeValue());
				   }
				   if (flink_Node.getNodeName() == "src") {
					   file_link_src = flink_Node.getFirstChild().getNodeValue();
					   System.out.println("file link source: "  + flink_Node.getFirstChild().getNodeValue());
						try {
							copy(new File(input_directory + file_link_src  ), new File(output_directory + file_link_src ) );
					    }catch (Exception e){//Catch exception if any
					    	System.err.println("Error: " + e.getMessage());
					    }	
				   }			   	
			   }
 //		<a target =\"new\" href=\"" + file_link_src +"\">" + file_link_name + "</a>

			   menu_array.add(new ArrayList<String>());
			   menu_array.get(menu_array.size()-1).add("<a target =\"new\" href=\"" + file_link_src + "\">" + file_link_name + "</a>");
			   menu_array.get(menu_array.size()-1).add("flink");
		   }		   
	   }
	   if (menu_array.size()>0) {
		   for (int t = 0; t < menu_array.size(); t++) {
			   if ( menu_array.get(t).get(1) == "page" ) 
			   {
				   String page_output_name = "";
				   String page_title = "";
				   Node pageNode = find_page_by_name(menu_array.get(t).get(0), XML_doc);
				   page_output_name = find_outputname_for_page(pageNode);
				   page_title = find_menu_title_for_page(pageNode);
				   
				   menu_html = menu_html + "<li class=\"" +  menu_array.get(t).get(0) + "\"" + "><a href=\"";
				   menu_html = menu_html +  page_output_name + "\">";
				   menu_html = menu_html + page_title;
				   menu_html = menu_html + "</a></li>\n";				   
			   }
			   if ( menu_array.get(t).get(1) == "flink" ) 
			   {
				   menu_html = menu_html + "<li>";
				   menu_html = menu_html + menu_array.get(t).get(0);
				   menu_html = menu_html + "</li>\n";
			   }			   
			   if ( menu_array.get(t).get(1) == "group" ) 
			   {
				   menu_html = menu_html +  menu_array.get(t).get(0);
			   }
			   
		   }
	   }
	
	   return_string  = return_string  + menu_html;
			   
		return return_string; 
	}
	
	
	private  String create_personal_schedule_html(String input_string)
	{	
		String return_string = "";
		//String input_string = "";
		//input_string = "M-F 5-6 Squash\nM-F 12-1 Bridge\nM 2-3 Lab Change Over\nT 9-12 Labs\nR 9-11 Labs\nR 11-12 IQP jw\n";
		//input_string += "WF 8-12 Labs\nTR 2-5 Labs\nF 1-4 Labs\nW 1-2 Labs\nW 2-3 Labs\nW 3-4 Labs\nTR 1-2 IQP s\n";
		//input_string += "M 8-12 Free Lab Time\nM 1-2 Free Lab Time\nT 8-9 Free Lab Time\nT 6-9 Free Lab Time\nW 4-5 Free Lab Time\n";
		//input_string += "W 6-9 Free Lab Time\nR 6-9 Free Lab Time\nR 8-9 Free Lab Time\nF 4-5 Free Lab Time\n";
		
		
		//input_string = "M-F 5-6 Squash\n";
		return_string  = build_sched(input_string, "8", "21", "TITLE",60);
		
		System.out.println(return_string);
	   
	   
		return return_string; 
	}
	 String weekdays="U=Sunday M=Monday T=Tuesday W=Wednesday R=Thursday F=Friday A=Saturday";
	public  String build_sched(String input_sched, String StartTime, String EndTime, String Title, int SlotWidth)
	{
		String return_string = "";
		String regschedule="";
		
		String digits=" 0123456789";
		 
		//String [] BGColor = null;
		String WEEKDAYS="UMTWRFA";
		int i=0;
		String s="";
		int ifirst=0;
		int ilast=0;
		int firsttime=0;
		int lasttime=23;	
		//int minopen=25;
		int slotwidth=60;
		int slotsperday=(lasttime-firsttime);
		slotwidth= SlotWidth;
		
		ifirst=timeof(StartTime,false, firsttime, lasttime, slotwidth, slotsperday);
		ilast=timeof(EndTime,false, firsttime, lasttime, slotwidth, slotsperday);
		firsttime=ifirst;
		lasttime=ilast;
		slotsperday=(lasttime-firsttime)*60/slotwidth;

		
		

		//setslots(60/Math.ceil(60/slotwidth));
		int ndays=7;

		WEEKDAYS=getdays("MTWRF", WEEKDAYS);
		ndays=WEEKDAYS.length();
		String[] S;

		int ipt=0;
		int itime=0;
		int iprev=0;
		int iday=0;
		String sline="";

		//var schedule=new Array(ndays+1);
		ArrayList<ArrayList<String>> schedule = new ArrayList<ArrayList<String>>();
		//var tr=new Array(ndays+1);
		ArrayList<ArrayList<Integer>> tr = new ArrayList<ArrayList<Integer>>();
		ArrayList<String> suser = new ArrayList<String>();
		ArrayList<String> stask = new ArrayList<String>();
		ArrayList<String> stime = new ArrayList<String>();
		ArrayList<String> sdata = new ArrayList<String>();
		int ndata=0;
		String sdisplay="";
		String thisuser="";
		boolean includekey=false;
		boolean includetime=false;
		String stitle=Title;
		String stext=input_sched;
		regschedule="";
		
		//split the inputstring into ilnes and put it in the array
		String[] input_by_line = stext.split("\n");
		 
		int iline_counter = 0;
		//run through the array
		while(input_by_line.length>iline_counter)
		{
			sline=input_by_line[iline_counter];
//System.out.println("input line: " + sline + "<br>");
			iline_counter++;
		  
//			if(sline.indexOf("bgcolor:")==0)
//			{
//				S=sline.split(":");
//				BGColor[Integer.parseInt(S[1])]=S[2];
//				if(includekey)sdisplay+="\n<br>"+sline ;
//				sline="";
//			}
			if(sline.indexOf(" = ")>=0)sline=sline.split(" = ")[1];
			if(sline.length()>0 && sline.indexOf(":")==sline.length()-1 && sline.indexOf(" ")<0)thisuser=sline;
			if (thisuser!=sline)
			{
				sline.replace(" AM","AM");
				sline.replace(" am","AM");
				sline.replace(" PM","PM");
				sline.replace(" pm","PM");
				String[] sinfo=sline.split(" ");
				if(sinfo.length>=2){
//System.out.println("sinfo[0]: " + sinfo[0] + "<br>");
//System.out.println("sinfo[1]: " + sinfo[1] + "<br>");
					if(sinfo.length>3){
						for(int k=3;k<sinfo.length;k++){
							sinfo[2] = sinfo[2] + " " + sinfo[k];
						}
					}
//System.out.println("sinfo[2]: " + sinfo[2] + "<br>");

					if(digits.indexOf(sinfo[0].charAt(0))>0){
						sdata.add(getweekcode(sinfo[1],sinfo[0], ndays, firsttime, lasttime, slotwidth, slotsperday, WEEKDAYS));
					}else{
						sdata.add(getweekcode(sinfo[0],sinfo[1], ndays, firsttime, lasttime, slotwidth, slotsperday, WEEKDAYS));
					}
//System.out.println("sdata: "+sdata.get(ndata) + "<br>");
//System.out.println("thisuser: "+thisuser + "<br>");
					
				    suser.add(thisuser);
				    stask.add((sinfo.length==2?"":includekey?ndata+" ("+sinfo[2]+")":sinfo[2]));
				    stime.add(sinfo[0]+" "+sinfo[1]);
				    
//System.out.println("stask: "+stask.get(ndata) + "<br>");
//System.out.println("stime: "+stime.get(ndata) + "<br>");
				    if(includekey)sdisplay+="\n<br>"+ndata+" = "+sline  ;
					ndata++; 				    
				}
			}
		 }
		 ipt=0;
		 //build a blank first entry for the tr and schedule arrays
		 schedule.add(new ArrayList<String>());
		 tr.add(new ArrayList<Integer>());
		  for(itime=0;itime<slotsperday;itime++){
			  schedule.get(0).add("");
			  tr.get(0).add(0);
			  
		  }
		  //builds the schedule array
		 for(iday=1;iday<=ndays;iday++)
		 {
			 schedule.add(new ArrayList<String>());
			 tr.add(new ArrayList<Integer>());
			  for(itime=0;itime<slotsperday;itime++)
			  {
				  schedule.get(iday).add("");
				  tr.get(iday).add(0);
			  }
			 
			 
			  for(itime=0;itime<slotsperday;itime++)
			  {
				  s="";
				  for(i=0;i<ndata;i++)
				  {
//System.out.println("sdata(i): "+ sdata.get(i).substring(ipt,ipt+1) + "<br>");
					  	if  (sdata.get(i).substring(ipt,ipt+1).equalsIgnoreCase("N")) { 
					  		s+="<br>"+suser.get(i)+stask.get(i)+(includetime?"<br />"+stime.get(i):"");
//					  		System.out.println("XXXX");
					  	} else {
					  		s+="";
					  	}
					  	//s+=(sdata.get(i).substring(ipt,ipt+1)=="N"?"<br>"+suser.get(i)+stask.get(i)+(includetime?"<br />"+stime.get(i):""):"");

				  }
//System.out.println("s: "+s + "<br>");		  
				  schedule.get(iday).set(itime, s);
				  if(itime>0 && schedule.get(iday).get(itime-1)==s){
					  iprev=itime-1;
					  i=tr.get(iday).get(iprev);
					  if(i<=0)iprev=-i;
					  tr.get(iday).set(iprev, tr.get(iday).get(iprev) +1);
					  tr.get(iday).set(itime, tr.get(iday).get(itime) +iprev);
				  }else{
					  tr.get(iday).set(itime,1);
				  }
				  ipt++;
			  }
			  ipt++; //newline  
		 }
		 //tr[0]=new Array(slotsperday);
		 for(itime=0;itime<slotsperday;itime++)
		 {
			 int imin=1000;
			 for(iday=1;iday<=ndays;iday++)
			 {
				 if(tr.get(iday).get(itime)>0)
				 {
					 imin=Math.min(imin,tr.get(iday).get(itime));
				 }else{
					 imin=Math.min(imin, tr.get(iday).get(-tr.get(iday).get(itime)) - tr.get(iday).get(itime) - itime );
				 }
			 }
			 tr.get(0).set(itime, imin);
		 }		
//	System.out.println("schedule: " + schedule + "<br>");
//	System.out.println("tr: " + tr + "<br>");
		
		 //s="<head>\n<title>"+stitle+"</title>\n<style>\n th{background-color:white;font-weight:bold;font-size:10pt}\n .open{color:red;background-color:white;font-size:10pt}\n .scheduled{background:lightgrey;font-size:10pt}\n.chapel{color:blue;background-color:yellow;font-size:10pt}\n</style>\n</head>\n";
		 s="<head><style>\n th{background-color:white;font-weight:bold;font-size:10pt}\n .open{color:red;background-color:white;font-size:10pt}\n .scheduled{background:lightgrey;font-size:10pt}\n.chapel{color:blue;background-color:yellow;font-size:10pt}\n</style>\n</head>\n";
		 //sdisplay=s+"<body>\n<h3>"+stitle+"</h3>\n"+maketable(schedule,tr, ndays, firsttime, slotwidth, slotsperday, WEEKDAYS)+"<pre>\n"+sdisplay+"\n</pre>\n"+regschedule+"</body>\n";
		 sdisplay=s+maketable(schedule,tr, ndays, firsttime, slotwidth, slotsperday, WEEKDAYS)+"<pre>\n"+sdisplay+"\n</pre>\n"+regschedule+"\n";
			
		 return_string  = sdisplay  ;
		 return return_string; 
	}
	 int timeof( String stime, boolean islate, int firsttime, int lasttime, int slotwidth, int slotsperday){
		 String s="";
		 int  i=0;
		 int hh=0;
		 Double mm=0.0;
		 s=stime;
		 
		 s=s.toUpperCase();
		 boolean ispm=(s.indexOf("P")>0);
		 boolean isam=(s.indexOf("A")>0);
		 s.replace("P","");
		 s.replace("A","");
		 s.replace("M","");
		 s.replace(" ","");
		 i=s.indexOf(":");
		 if(i<0&&s.length()==4){
			isam=(s.startsWith("0"));
			s=s.substring(isam?1:0,2)+":"+s.substring(2,4);
		 }
		 if (s.indexOf(":")<0)s+=":00";
//System.out.println("timeof: " + s);		 
		 String[] S=s.split(":");		 
		 hh=Integer.parseInt(S[0]);
		 if(hh==12){
			isam=!isam;
			ispm=!ispm;
		 }
		 hh+=(!isam && (ispm || hh<firsttime)?12:0);
		 hh=(hh-firsttime)*60/slotwidth;
//System.out.println(hh);
		 s="1."+S[1];
//System.out.println(s);
		 mm=Double.parseDouble(s)-0.9999;
		 mm-=(islate?0.01:0);
		 mm=mm*100/slotwidth;
		 i=(int) Math.floor(hh+mm);
		 if(i<0)i=0;
		 if(i>=slotsperday)i=slotsperday;
		 return i;
	}
	 String  getdays(String dayinfo, String WEEKDAYS){
		//String WEEKDAYS="UMTWRFA";
		String sdays="";
		String s="";
		int i=0;
		String s1="";
		String s2="";
		int i1=0;
		int i2=0;
		sdays=fixdays(dayinfo,true);
		i=sdays.indexOf("-");
		if (i>0){
			  s1=sdays.substring(i-1,i);
			  s2=sdays.substring(i+1,i+2);
			  i1=WEEKDAYS.indexOf(s1);
			  i2=WEEKDAYS.indexOf(s2);
			  if(i1>=0 && i2>i1)sdays=s1+WEEKDAYS.substring(i1+1,i2)+s2;
		}
		return sdays;
	}	
	 String fixdays(String sdays,boolean toURA){
		 String s=sdays;
		 if(toURA){
		  if(s=="")s="MTWRF";
		  s=s.toUpperCase();
		  s.replace("SU","U");
		  s.replace("SA","A");
		  s.replace("TH","R");
		  s.replace("Th","R");
		  return s;
		 }
		 s.replace("U","Su");
		 s.replace("A","Sa");
		 s.replace("R","Th");
		 return s;
	}	
	
	 String  getweekcode(String dayinfo,String timeinfo, int ndays, int firsttime, int lasttime, int slotwidth, int slotsperday, String WEEKDAYS){
//		String WEEKDAYS="UMTWRFA";
		 String sdays="";
		 String s="";
		 int i=0;
		 String sout="";
		 String daycode=getdaycode(timeinfo, firsttime, lasttime, slotwidth, slotsperday);
//System.out.println("daycode: " + daycode + "<br>");
		 sdays=getdays(dayinfo, WEEKDAYS);
		 for(i=0;i<ndays;i++){
		  s=String.valueOf(WEEKDAYS.charAt(i));
		  sout+=(sdays.indexOf(s)>=0?daycode:getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday))+"\n";
		 }
		 return sout;
	}	
	 String getdaycode(String timeinfo, int firsttime, int lasttime, int slotwidth, int slotsperday){
		 String s="";
		 int i=0;
		 String[] stimes;
		 int itime1=0;
		 int itime2=0;
		 i=timeinfo.indexOf("-");
		 if(i<=0)return getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday);
		 stimes=timeinfo.split("-");
//System.out.println("starttime: " + stimes[0]+ "<br>");
//System.out.println("endtime: " + stimes[1]+ "<br>");
		 itime1=timeof(stimes[0],false, firsttime, lasttime, slotwidth, slotsperday);
		 itime2=timeof(stimes[1],true, firsttime, lasttime, slotwidth, slotsperday)+1;
		 System.out.println(itime1+"<br>\n");
		 System.out.println(itime2+"<br>\n");	
//System.out.println("TEST"+"<br>\n");
		 if(itime2<=itime1)return getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday);
//System.out.println(getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(0,itime1) + "<br>");
//System.out.println(getFULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(itime1,itime2)+ "<br>");
//System.out.println(getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(itime2,slotsperday)+ "<br>");
		 s=getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(0,itime1)+getFULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(itime1,itime2)+getNULLDAYSslots(firsttime, lasttime, slotwidth, slotsperday).substring(itime2,slotsperday);
		 //alert(timeinfo+"\n"+itime1+ "\n"+ s +"\n"+ itime2)
//System.out.println("end of getdaycode: " + timeinfo+"<br>\n"+itime1+ "<br>\n"+ s +"<br>\n"+ itime2+"<br>\n");
		 return s;
		 
	}	

	 String getNULLDAYSslots(int firsttime, int lasttime, int slotwidth, int slotsperday){
		String NULLDAY = "";
		 for(int i=0;i<slotsperday;i++)NULLDAY+="Y";
		 return NULLDAY;
	}	
	
	 String getFULLDAYSslots( int firsttime, int lasttime, int slotwidth, int slotsperday)
	{
		String FULLDAY = "";
		 for(int i=0;i<slotsperday;i++)FULLDAY+="N";
		 return FULLDAY;
	}

	
	
	
	public  String maketable(ArrayList<ArrayList<String>> schedule, ArrayList<ArrayList<Integer>> tr, int ndays, int firsttime, int slotwidth, int slotsperday, String WEEKDAYS){
		 int i=0;
		 //String WEEKDAYS="UMTWRFA";
		 String s="";
		 int iday=0;
		 int itime=0;
		 int minopen=25;

		 //int igroup=document.frm.grouptimes.checked\
		 int igroup = 1;
		 String sopen="";
		 //String bgcolor="";
		 String sout="\n<table border=1 width=100%>\n<tr>\n<td nowrap></td>";
		 s="\n<th width=" + Math.floor(100/(ndays+1)) + "%>";
		 for(iday=0;i<ndays;i++) {
			 sout+=s+fieldof(weekdays,WEEKDAYS.charAt(i))+"</th>";
		 }
		 sout+="\n</tr>";
		 for(itime=0;itime<slotsperday;itime++){
		  if(igroup>0){
			i=tr.get(0).get(itime);
			s=hhmmof(itime, firsttime, slotwidth)+" - "+hhmmof(itime+i, firsttime, slotwidth);
			if(s.indexOf("AM")!=s.lastIndexOf("AM")) {
				s=s.replace(" AM","");
			}
			if(s.indexOf("PM")!=s.lastIndexOf("PM")) {
				s=s.replace(" PM","");
			}
			sout+="\n<tr><th"+(i>1?" rowspan="+i:"")+" nowrap>"+s+"</th>";	
		  }else{
			sout+="\n<tr><th nowrap>"+hhmmof(itime, firsttime, slotwidth)+"</th>";
		  }
		  for(iday=1;iday<=ndays;iday++){
		   s=schedule.get(iday).get(itime);
		   if(s.length()>0){
			   if(igroup>0){
				   s = s + "<br>&nbsp;";
		   	   }else{
		   			s=s.substring(4,s.length());
			   }
		   }
		   i=tr.get(iday).get(itime);
		   sopen=(i*slotwidth>minopen?"<br>OPEN<br>&nbsp;":"");
//		   bgcolor=getbgcolor(s);
		   if(i>0) {
//			   sout+="\n<td align=center"+(i>1?" rowspan="+i:"")+(s.indexOf("Chapel")>=0?" class=chapel>"+s:s.length()>0?(bgcolor?bgcolor:" class=scheduled ")+">"+s:" class=open>"+sopen)+"</td>";			   
			   sout+="\n<td align=center"+(i>1?" rowspan="+i:"")+(s.indexOf("Chapel")>=0?" class=chapel>"+s:s.length()>0?" class=scheduled "+">"+s:" class=open>"+sopen)+"</td>";
		   }
		  }
		  if(igroup>0){
			s="";
			for(iday=1;iday<=ndays;iday++) {
				s+="<td></td>";
			}
			for(i=1;i<tr.get(0).get(itime);i++) {
				sout+="\n</tr>\n<tr>"+s;
			}
			itime+=tr.get(0).get(itime)-1;
		  }
		  sout+="\n</tr>";
		 }   
		 sout+="\n</table>";
		 //sout+="\n<p>\n<small>Created using <a href=http://www.stolaf.edu/people/hansonr/mysched>http://www.stolaf.edu/people/hansonr/mysched</a></small>\n";
		 return sout;
	}
	 String fieldof(String slist, char schar){
		 int i=slist.indexOf(schar+"=");
		 if(i<0)return "";
		 String s=slist.substring(i+2,slist.length());
		 i=s.indexOf(" ");
		 if(i<0)return s;
		 return s.substring(0,i);
	}
	
	//takes an int time and returns it into HH:MM format
	 String hhmmof(int itime, int firsttime, int slotwidth){
		 String s="";
		 int hh=0;
		 int mm=itime*slotwidth; 
		 hh=(int) Math.floor(mm/60);
		 mm=(int) Math.floor(mm-hh*60); 
		 hh+=firsttime;
		 boolean ispm=(hh>=12);
		 if (hh>12) hh=hh-12;
		 String smm="00"+mm;
		 smm=smm.substring(smm.length()-2,smm.length());
		 s=hh+":"+smm+" "+(ispm?"PM":"AM");
		 return s;
	}

//	 String getbgcolor(String s){
//		 String c="";
//		 for(int i : BGColor){
//			if(s.indexOf(i)>=0)c=" bgcolor="+BGColor[i];
//		 }
//		 return c;
//	}


	

	public  void copy(File source, File dest) throws IOException {
	     FileChannel in = null, out = null;
	     try {          
	          in = new FileInputStream(source).getChannel();
	          out = new FileOutputStream(dest).getChannel();
	 
	          long size = in.size();
	          MappedByteBuffer buf = in.map(FileChannel.MapMode.READ_ONLY, 0, size);
	 
	          out.write(buf);
	 
	     } finally {
	          if (in != null)          in.close();
	          if (out != null)     out.close();
	     }
	}

	private  int check_for_event_in_event_array(Calendar CheckDate, ArrayList<ArrayList<String>> event_array)
	{
		   //event_array[n][1]: year
		   //event_array[n][2]: month
		   //event_array[n][3]: day		
		int index_of_event = -1;
		for (int t = 0; t < event_array.size(); t++) {
			if (CheckDate.get(Calendar.DATE) ==  Integer.parseInt(event_array.get(t).get(3))) {
				if (CheckDate.get(Calendar.MONTH) +1 ==  Integer.parseInt(event_array.get(t).get(2))) {	
					if (CheckDate.get(Calendar.YEAR) ==  Integer.parseInt(event_array.get(t).get(1))) {
						return t;
						
					}
				}
			}
			
		}
		return index_of_event;
	}
}

